; TODO (Gleb Larionov for ES1841, see comment with 'GLEB') : 
;        + Add CGA and MDA Character generators (CHARACTER 249 IS MODIFYED HERE !!! - SEE BOTTOM)
;        + Add RAM board 2B0 initialization
;        + DMA Refresh Correction
;        + Other Small changes
;        + Correct ROM CRC
;        + Correct read Switches
;        + Correct read Floppy
;        + Remove check ROM at F000 segments
;        + Why on 512K RAM Board End of RAM is 0 ? - WAS A BUG - FIXED
;        - INSUFF SIZE OF ROM: Check floppy double steps (and compare jumper) 
;        - INSUFF SIZE OF ROM: Check Memory Board Port 2B0, show if present or not, maybe show 1840/41
;==============================================================================
;
; 	          Diagnostic ROM for IBM-PC/XT and compatibles
;
;			   Written by Ruud Baltissen
;
;
; Notes:
; -	This ROM can be used to diagnose the IBM-PC, IBM-XT and compatible 
;	computers. 
; -	This version only supports the MDA and CGA video adapter. The reason: 
;	the EGA and VGA cards need to be initialized by their own ROMs and I'm
;	sure that they run subroutines and therefore need RAM for the stack. 
;	The Landmark diagnostic ROM supports EGA by using its own routines but
;	1) IMHO that needs more effort than it is worth the trouble and time
;	and 2) and EGA monitors are rare nowadays.

; -	This test simply expects either a MDA or a CGA video present. It will
;	beep after the checksum test to inform the user that the test is running
;	fine so far. But if there is nothing on the screen at that point, there
;	is either something wrong with the board or a part of the video system.
; -	For the future: a version that does beep at every stage for those 
;	people that don't have a MDA or CGA video system. 
; -	The beeping will represent the binary code: a long beep is an one, a
;	short beep is a zero. 

;%define SoundDebug		; sound the codes during OutDebug


; -	If the CPU is to be found bad, the test stops. Why continuing with a
;	bad processor? Remark: a bad EPROM can cause this error as well.
; -	If the checksum of the EPROM is not correct, the test stops. If I can't
;	trust the EPROM, can I trust the outcome of the following tests?
; -	If the program can't find 2 KB of good memory from 0000:0000h on, the
;	test will stop as well. The rest of the program needs RAM for the
;	interrupt vectors and subroutines. Without RAM that is not possible. 
;	I know Landmark can continue by using this ROM-Stack method but this is
;	a very labour intensive way of programming. I'm interested in repairing
;	PCs with this tool and if the memory is bad, then repair that problem
;	first before looking for possible other problems.
; -	General remark: broken glue logic and buffers can cause errors that are
;	interpreted wrong by this diagnostic ROM or errors that won't be 
;	detected at all. For example: a broken data buffer can cause that 
;	nothing shows up at the screen althought the card itself is fine.

; Versions
;	This is a project I do just for fun. So I have no intention to keep
;	track of any change I made. In case of a major change I will save a
;	dated copy but that is all.

; Disclaimer
; -	All names with a copyright are acknowledged.
; -	Some information is derived from deduction after reading a lot of
;	documents and can be unreliable due to the lack of real proof.
; -	If you use this source code and the resulting binary, then it is on
;	your own account. I cannot be held responsible for blowing up your
;	computer, mother-in-law or whatever; it will always be your own fault.
;	USING THIS SOURCE CODE AND ITS BINARY IS COMPLETELY AT YOUR OWN RISK !!!
; -	I'm a Dutchman and English is not my native language. So you can expect
;	to find several linguistic mistakes.



;-------------------------------------------------------------------------------
; I/O port information
;-------------------------------------------------------------------------------
DMA8237		equ	0		; 00h - 1Fh

PIC8259		equ	20h		; 20h - 21h

PIT8253A	equ	40h
PIT8253B	equ	41h
PIT8253C	equ	42h
PIT8253Ctrl	equ	43h

; Programmable Peripheral Interface 8255
i8255A		equ	60h	; read key board OR (PC only) read switches
i8255B		equ	61h
;0061	w	system control port
;		 bit 7 = 1  clear keyboard + (PC only) enable read dip switches
;		 bit 6 = 0  hold keyboard clock low
;		 bit 5 = 0  I/O check enable
;		 bit 4 = 0  RAM parity check enable
;		 bit 3 = 0  XT: read low switches - PC: cassette motor on
;		 bit 2 = 1  XT: reserved / turbo ON - PC: read switches
;		 bit 1 = 1  speaker data enable
;		 bit 0 = 1  timer 2 gate to speaker enable
i8255C		equ	62h
;		 bit 7      read/write memory parity check
;		 bit 6      I/O channel check
;		 bit 5      timer channel 2 OUT
;		 bit 4      spare + (PC only) cassette data in
; XT:
;		 bit 3      SW-4: RAM size 1        Floppy drives 0
;		 bit 2      SW-3: RAM size 0    OR  Floppy drives 1
;		 bit 1      SW-2: co-processor      Video displa 0
;		 bit 0      SW-2: loop on post      Video displa 1
; PC:
;		 bit 3      memory SW2-4
;		 bit 2      memory SW2-3
;		 bit 1      memory SW2-2
;		 bit 0      memory SW2-1  OR  spare SW2-5
i8255Ctrl	equ	63h

DebugIO		equ	80h

; DMA page register
DmaPageRegCh2	equ	81h
DmaPageRegCh3	equ	82h
DmaPageRegCh1	equ	83h

NmiPort		equ	0A0h

MDA_addr	equ	3B4h
MDA_data	equ	3B5h
MDA_ctrl	equ	3B8h

CGA_addr	equ	3D4h
CGA_data	equ	3D5h
CGA_ctrl	equ	3D8h

FdcMotor	equ	3F2h
FdcStatus	equ	3F4h


SegmentMDA	equ	0B000h
SegmentCGA	equ	0B800h


;-------------------------------------------------------------------------------
; Memory reserved for the counters
;-------------------------------------------------------------------------------
InvScreenRAM	equ	4000		; start of invisible screen RAM
ControlWord	equ	InvScreenRAM
Err8253Ch0	equ	InvScreenRAM+2
Err8253Ch1	equ	InvScreenRAM+3
Err8253Ch2	equ	InvScreenRAM+4
Err8237DMA	equ	InvScreenRAM+5
Err8255Parity	equ	InvScreenRAM+6
Err2KbRAM	equ	InvScreenRAM+7
Err8259PIC	equ	InvScreenRAM+8
ErrBadIRQ	equ	InvScreenRAM+9
ErrINT0		equ	InvScreenRAM+10
ErrNMI		equ	InvScreenRAM+11
ErrMemoryMDA	equ	InvScreenRAM+12
ErrMemoryCGA	equ	InvScreenRAM+13
Err8087		equ	InvScreenRAM+14
ErrKeybCntr	equ	InvScreenRAM+15
ErrKeybScan	equ	InvScreenRAM+16
ErrFDC		equ	InvScreenRAM+17
ErrFdcRead	equ	InvScreenRAM+18
ErrRomF400	equ	InvScreenRAM+19
ErrRomF600	equ	InvScreenRAM+20
ErrRomF800	equ	InvScreenRAM+21
ErrRomFA00	equ	InvScreenRAM+22
ErrRomFC00	equ	InvScreenRAM+23
TotalCount	equ	InvScreenRAM+24


;-------------------------------------------------------------------------------
; Create the needed size
;-------------------------------------------------------------------------------
%ifdef Size32KB
 START		equ 08000h		; BIOS starts at offset 8000h
%elifdef Size16KB
 START		equ 0C000h		; BIOS starts at offset C000h
%else
 START		equ 0E000h		; BIOS starts at offset E000h
%endif



;=========================================================================
; setloc - Set location. Insert 0FFh bytes until specifed location is reached.
;-------------------------------------------------------------------------
%imacro setloc  1.nolist
%assign pad_bytes (%1-($-$$)-START)
%if pad_bytes < 0
%assign over_bytes -pad_bytes
%error Preceding code extends beyond setloc location by over_bytes bytes
%endif
%if pad_bytes > 0
%warning Inserting pad_bytes bytes
 times  pad_bytes db 0FFh
%endif
%endm



;**  Update the error counter in front of the text FAILED
;	using ROM stack
; %1 = pointer to line number
; %2 = pointer to error counter
; %3 = pointer to the next test
%macro MacFailed 3
	mov	si,%1
	mov	di,26			; position on the line
	mov	sp,.m10
	jmp	CalcSpotScreen

.m10:
	dw .m12


; DI now points to the correct possition on the screen
.m12:
	mov	sp,.m20
	mov	bx,%2
	jmp	GetErrorValue

.m20:
	dw .m22



; DX/BL contains decimal number
; DI contains location on the screem
.m22:
	mov	sp,.m24
	jmp	DisplayValue

.m24:
	dw .m26

.m26:
	mov	sp,%3
	mov	si,%1
	jmp	DisplayFailed
%endmacro



;**  Output a debug code to the two main LPT ports and IBM's debug port
; REMARK: meant only for parts where RAM for subroutines is NOT available !!!
%macro OutDebug 1
	mov	al,%1

%ifndef SoundDebug
	out	80h,al			; IBM's debug port
	
	mov	dx,378h			; LPT 1
	out	dx,al

	dec	dh
	out	dx,al			; LPT 2
%else
	mov	al,%1
	mov	sp,%%O20
	jmp	OutBeeep

%%O20:
	dw %%O40
%%O40:
	xor	cx,cx
%%O50:
	loop	%%O50
%%O60:
	loop	%%O60
%%O70:
	loop	%%O70
%endif

%endmacro



;**  Output a debug code to the two main LPT ports and IBM's debug port
; REMARK: meant only for parts where RAM for subroutines is available !!!
%macro OutDebugB 1
	mov	al,%1
	call	sOutDebug

 %ifdef SoundDebug
	call	Beeep
	call	Delay3			; between complete code beeps delay
 %endif
%endmacro

 

BITS 16

CPU 8086



;-------------------------------------------------------------------------------
; Start of the actual ROM
;-------------------------------------------------------------------------------

	org	START

%ifdef Size32KB
	setloc	08000h			; 32 KB ROM BIOS
%endif

%ifdef Size16KB
	setloc	0C000h			; 16 KB ROM BIOS
%endif


	setloc	0E000h			; 8 KB ROM BIOS


L_E000:

;------------------------------------------------------------------------------
; Version code
;------------------------------------------------------------------------------

;;;GLEB	db 'No copyright, all open source. '
;;;GLEB	db 'Author Ruud Baltissen '
	db 'No copyright-open source, Author Ruud Baltissen'
;;;GLEB	db 'Modifyed Gleb Larionov (ES-1841) '		;;;GLEB
;;;GLEB	db 'Version: '
;;;GLEB	db __DATE__, 32		; Release date (YYYY-MM-DD)
;;;GLEB	db __TIME__ 		; Release time (uu:mm:ss)
;;;GLEB	db ' '
 
;;;GLEB ->

Char_Gen:	; From ES-1841 but change to "alternate" and symbol 249 replaced to little dot for better humper view

 	db	000h,000h,000h,000h,000h,000h,000h,000h ;d_00
 	db	07eh,081h,0a5h,081h,0bdh,099h,081h,07eh ;d_01
 	db	07eh,0ffh,0dbh,0ffh,0c3h,0e7h,0ffh,07eh ;d_02
 	db	06ch,0feh,0feh,0feh,07ch,038h,010h,000h ;d_03
 	db	010h,038h,07ch,0feh,07ch,038h,010h,008h ;d_04
 	db	038h,07ch,038h,0feh,0feh,07ch,038h,07ch ;d_05
 	db	010h,010h,038h,07ch,0feh,07ch,038h,07ch ;d_06
 	db	000h,000h,018h,03ch,03ch,018h,000h,000h ;d_07
 	db	0ffh,0ffh,0e7h,0c3h,0c3h,0e7h,0ffh,0ffh ;d_08
 	db	000h,03ch,066h,042h,042h,066h,03ch,000h ;d_09
 	db	0ffh,0c3h,099h,0bdh,0bdh,099h,0c3h,0ffh ;d_0a
 	db	00fh,007h,00fh,07dh,0cch,0cch,0cch,078h ;d_0b
 	db	03ch,066h,066h,066h,03ch,018h,07eh,018h ;d_0c
 	db	03fh,033h,03fh,030h,030h,070h,0f0h,0e0h ;d_0d
 	db	07fh,063h,07fh,063h,063h,067h,0e6h,0c0h ;d_0e
 	db	099h,05ah,03ch,0e7h,0e7h,03ch,05ah,099h ;d_0f

 	db	080h,0e0h,0f8h,0feh,0f8h,0e0h,080h,000h ;d_10
 	db	002h,00eh,03eh,0feh,03eh,00eh,002h,000h ;d_11
 	db	018h,03ch,07eh,018h,018h,07eh,03ch,018h ;d_12
 	db	066h,066h,066h,066h,066h,000h,066h,000h ;d_13
 	db	07fh,0dbh,0dbh,07bh,01bh,01bh,01bh,000h ;d_14
 	db	03eh,063h,038h,06ch,06ch,038h,0cch,078h ;d_15
 	db	000h,000h,000h,000h,07eh,07eh,07eh,000h ;d_16
 	db	018h,03ch,07eh,018h,07eh,03ch,018h,0ffh ;d_17
 	db	018h,03ch,07eh,018h,018h,018h,018h,000h ;d_18
 	db	018h,018h,018h,018h,07eh,03ch,018h,000h ;d_19
 	db	000h,018h,00ch,0feh,00ch,018h,000h,000h ;d_1a
 	db	000h,030h,060h,0feh,060h,030h,000h,000h ;d_1b
 	db	000h,000h,0c0h,0c0h,0c0h,0feh,000h,000h ;d_1c
 	db	000h,024h,066h,0ffh,066h,024h,000h,000h ;d_1d
 	db	000h,018h,03ch,07eh,0ffh,0ffh,000h,000h ;d_1e
 	db	000h,0ffh,0ffh,07eh,03ch,018h,000h,000h ;d_1f

 	db	000h,000h,000h,000h,000h,000h,000h,000h ;sp d_20
 	db	030h,078h,078h,030h,030h,000h,030h,000h ;! d_21
 	db	06ch,06ch,06ch,000h,000h,000h,000h,000h ;"d_22
 	db	06ch,06ch,0feh,06ch,0feh,06ch,06ch,000h ;# d_23
 	db	030h,07ch,0c0h,078h,00ch,0f8h,030h,000h ;$ d_24
 	db	000h,0c6h,0cch,018h,030h,066h,0c6h,000h ;per cent d_25
 	db	038h,06ch,038h,076h,0dch,0cch,076h,000h ;& d_26
 	db	060h,060h,0c0h,000h,000h,000h,000h,000h ;' d_27
 	db	018h,030h,060h,060h,060h,030h,018h,000h ;( d_28
 	db	060h,030h,018h,018h,018h,030h,060h,000h ;) d_29
 	db	000h,066h,03ch,0ffh,03ch,066h,000h,000h ;* d_2a
 	db	000h,030h,030h,0fch,030h,030h,000h,000h ;+ d_2b
 	db	000h,000h,000h,000h,000h,030h,030h,060h ;, d_2c
 	db	000h,000h,000h,0fch,000h,000h,000h,000h ;- d_2d
 	db	000h,000h,000h,000h,000h,030h,030h,000h ;. d_2e
 	db	006h,00ch,018h,030h,060h,0c0h,080h,000h ;/ d_2f

 	db	07ch,0c6h,0ceh,0deh,0f6h,0e6h,07ch,000h ;0 d_30
 	db	030h,070h,030h,030h,030h,030h,0fch,000h ;1 d_31
 	db	078h,0cch,00ch,038h,060h,0cch,0fch,000h ;2 d_32
 	db	078h,0cch,00ch,038h,00ch,0cch,078h,000h ;3 d_33
 	db	01ch,03ch,06ch,0cch,0feh,00ch,01eh,000h ;4 d_34
 	db	0fch,0c0h,0f8h,00ch,00ch,0cch,078h,000h ;5 d_35
 	db	038h,060h,0c0h,0f8h,0cch,0cch,078h,000h ;6 d_36
 	db	0fch,0cch,00ch,018h,030h,030h,030h,000h ;7 d_37
 	db	078h,0cch,0cch,078h,0cch,0cch,078h,000h ;8 d_38
 	db	078h,0cch,0cch,07ch,00ch,018h,070h,000h ;9 d_39
 	db	000h,030h,030h,000h,000h,030h,030h,000h ;: d_3a
 	db	000h,030h,030h,000h,000h,030h,030h,060h ;; d_3b
 	db	018h,030h,060h,0c0h,060h,030h,018h,000h ;< d_3c
 	db	000h,000h,0fch,000h,000h,0fch,000h,000h ;= d_3d
 	db	060h,030h,018h,00ch,018h,030h,060h,000h ;> d_3e
 	db	078h,0cch,00ch,018h,030h,000h,030h,000h ;? d_3f

 	db	07ch,0c6h,0deh,0deh,0deh,0c0h,078h,000h ;@ d_40
 	db	030h,078h,0cch,0cch,0fch,0cch,0cch,000h ;A d_41
 	db	0fch,066h,066h,07ch,066h,066h,0fch,000h ;B d_42
 	db	03ch,066h,0c0h,0c0h,0c0h,066h,03ch,000h ;C d_43
 	db	0f8h,06ch,066h,066h,066h,06ch,0f8h,000h ;D d_44
 	db	0feh,062h,068h,078h,068h,062h,0feh,000h ;E d_45
 	db	0feh,062h,068h,078h,068h,060h,0f0h,000h ;F d_46
 	db	03ch,066h,0c0h,0c0h,0ceh,066h,03eh,000h ;G d_47
 	db	0cch,0cch,0cch,0fch,0cch,0cch,0cch,000h ;H d_48
 	db	078h,030h,030h,030h,030h,030h,078h,000h ;I d_49
 	db	01eh,00ch,00ch,00ch,0cch,0cch,078h,000h ;J d_4a
 	db	0e6h,066h,06ch,078h,06ch,066h,0e6h,000h ;K d_4b
 	db	0f0h,060h,060h,060h,062h,066h,0feh,000h ;L d_4c
 	db	0c6h,0eeh,0feh,0feh,0d6h,0c6h,0c6h,000h ;M d_4d
 	db	0c6h,0e6h,0f6h,0deh,0ceh,0c6h,0c6h,000h ;N d_4e
 	db	038h,06ch,0c6h,0c6h,0c6h,06ch,038h,000h ;O d_4f

 	db	0fch,066h,066h,07ch,060h,060h,0f0h,000h ;P d_50
 	db	078h,0cch,0cch,0cch,0dch,078h,01ch,000h ;Q d_51
 	db	0fch,066h,066h,07ch,06ch,066h,0e6h,000h ;R d_52
 	db	078h,0cch,0e0h,070h,01ch,0cch,078h,000h ;S d_53
 	db	0fch,0b4h,030h,030h,030h,030h,078h,000h ;T d_54
 	db	0cch,0cch,0cch,0cch,0cch,0cch,0fch,000h ;U d_55
 	db	0cch,0cch,0cch,0cch,0cch,078h,030h,000h ;V d_56
 	db	0c6h,0c6h,0c6h,0d6h,0feh,0eeh,0c6h,000h ;W d_57
 	db	0c6h,0c6h,06ch,038h,038h,06ch,0c6h,000h ;X d_58
 	db	0cch,0cch,0cch,078h,030h,030h,078h,000h ;Y d_59
 	db	0feh,0c6h,08ch,018h,032h,066h,0feh,000h ;Z d_5a
 	db	078h,060h,060h,060h,060h,060h,078h,000h ;( d_5b
 	db	0c0h,060h,030h,018h,00ch,006h,002h,000h ;backslash
 	db	078h,018h,018h,018h,018h,018h,078h,000h ;) d_5d
 	db	010h,038h,06ch,0c6h,000h,000h,000h,000h ;cimpqumflex
 	db	000h,000h,000h,000h,000h,000h,000h,0ffh ;_ d_5f

 	db	030h,030h,018h,000h,000h,000h,000h,000h ;  d_60
 	db	000h,000h,078h,00ch,07ch,0cch,076h,000h ;lower case a
 	db	0e0h,060h,060h,07ch,066h,066h,0dch,000h ;b d_62
 	db	000h,000h,078h,0cch,0c0h,0cch,078h,000h ;c d_63
 	db	01ch,00ch,00ch,07ch,0cch,0cch,076h,000h ;d d_64
 	db	000h,000h,078h,0cch,0fch,0c0h,078h,000h ;e d_65
 	db	038h,06ch,060h,0f0h,060h,060h,0f0h,000h ;f d_66
 	db	000h,000h,076h,0cch,0cch,07ch,00ch,0f8h ;g d_67
 	db	0e0h,060h,06ch,076h,066h,066h,0e6h,000h ;h d_68
 	db	030h,000h,070h,030h,030h,030h,078h,000h ;i d_69
 	db	00ch,000h,00ch,00ch,00ch,0cch,0cch,078h ;j d_6a
 	db	0e0h,060h,066h,06ch,078h,06ch,0e6h,000h ;k d_6b
 	db	070h,030h,030h,030h,030h,030h,078h,000h ;l d_6c
 	db	000h,000h,0cch,0feh,0feh,0d6h,0c6h,000h ;m d_6d
 	db	000h,000h,0f8h,0cch,0cch,0cch,0cch,000h ;n d_6e
 	db	000h,000h,078h,0cch,0cch,0cch,078h,000h ;o d_6f

 	db	000h,000h,0dch,066h,066h,07ch,060h,0f0h ;p d_70
 	db	000h,000h,076h,0cch,0cch,07ch,00ch,01eh ;q d_71
 	db	000h,000h,0dch,076h,066h,060h,0f0h,000h ;r d_72
 	db	000h,000h,07ch,0c0h,078h,00ch,0f8h,000h ;s d_73
 	db	010h,030h,07ch,030h,030h,034h,018h,000h ;t d_74
 	db	000h,000h,0cch,0cch,0cch,0cch,076h,000h ;u d_75
 	db	000h,000h,0cch,0cch,0cch,078h,030h,000h ;v d_76
 	db	000h,000h,0c6h,0d6h,0feh,0feh,06ch,000h ;w d_77
 	db	000h,000h,0c6h,06ch,038h,06ch,0c6h,000h ;x d_78
 	db	000h,000h,0cch,0cch,0cch,07ch,00ch,0f8h ;y d_79
 	db	000h,000h,0fch,098h,030h,064h,0fch,000h ;z d_7a
 	db	01ch,030h,030h,0e0h,030h,030h,01ch,000h ;  d_7b
 	db	018h,018h,018h,000h,018h,018h,018h,000h ;  d_7c
 	db	0e0h,030h,030h,01ch,030h,030h,0e0h,000h ;  d_7d
 	db	076h,0dch,000h,000h,000h,000h,000h,000h ;  d_7e
 	db	000h,010h,038h,06ch,0c6h,0c6h,0feh,000h ;delta d_7f

	db	01eh,036h,066h,066h,07eh,066h,066h,000h	; 128	
	db	07ch,060h,060h,07ch,066h,066h,07ch,000h	; 129	
	db	07ch,066h,066h,07ch,066h,066h,07ch,000h	; 130	
	db	07eh,060h,060h,060h,060h,060h,060h,000h	; 131	
	db	038h,06ch,06ch,06ch,06ch,06ch,0feh,0c6h	; 132	
	db	07eh,060h,060h,07ch,060h,060h,07eh,000h	; 133	
	db	0dbh,0dbh,07eh,03ch,07eh,0dbh,0dbh,000h	; 134	
	db	03ch,066h,006h,01ch,006h,066h,03ch,000h	; 135	
	db	066h,066h,06eh,07eh,076h,066h,066h,000h	; 136	
	db	03ch,066h,06eh,07eh,076h,066h,066h,000h	; 137	
	db	066h,06ch,078h,070h,078h,06ch,066h,000h	; 138	
	db	01eh,036h,066h,066h,066h,066h,066h,000h	; 139	
	db	0c6h,0eeh,0feh,0feh,0d6h,0c6h,0c6h,000h	; 140	
	db	066h,066h,066h,07eh,066h,066h,066h,000h	; 141	
	db	03ch,066h,066h,066h,066h,066h,03ch,000h	; 142	
	db	07eh,066h,066h,066h,066h,066h,066h,000h	; 143	

	db	07ch,066h,066h,066h,07ch,060h,060h,000h	; 144	
	db	03ch,066h,060h,060h,060h,066h,03ch,000h	; 145	
	db	07eh,018h,018h,018h,018h,018h,018h,000h	; 146	
	db	066h,066h,066h,03eh,006h,066h,03ch,000h	; 147	
	db	07eh,0dbh,0dbh,0dbh,07eh,018h,018h,000h	; 148	
	db	066h,066h,03ch,018h,03ch,066h,066h,000h	; 149	
	db	066h,066h,066h,066h,066h,066h,07fh,003h	; 150	
	db	066h,066h,066h,03eh,006h,006h,006h,000h	; 151	
	db	0dbh,0dbh,0dbh,0dbh,0dbh,0dbh,0ffh,000h	; 152	
	db	0dbh,0dbh,0dbh,0dbh,0dbh,0dbh,0ffh,003h	; 153	
	db	0e0h,060h,060h,07ch,066h,066h,07ch,000h	; 154	
	db	0c6h,0c6h,0c6h,0f6h,0deh,0deh,0f6h,000h	; 155	
	db	060h,060h,060h,07ch,066h,066h,07ch,000h	; 156	
	db	078h,00ch,006h,03eh,006h,00ch,078h,000h	; 157	
	db	0ceh,0dbh,0dbh,0fbh,0dbh,0dbh,0ceh,000h	; 158	
	db	03eh,066h,066h,066h,03eh,036h,066h,000h	; 159	

	db	000h,000h,078h,00ch,07ch,0cch,076h,000h	; 160	
	db	000h,03ch,060h,03ch,066h,066h,03ch,000h	; 161	
	db	000h,03ch,066h,07ch,066h,066h,07ch,000h	; 162	
	db	000h,000h,07eh,060h,060h,060h,060h,000h	; 163	
	db	000h,000h,03ch,06ch,06ch,06ch,0feh,0c6h	; 164	
	db	000h,000h,03ch,066h,07eh,060h,03ch,000h	; 165	
	db	000h,000h,0dbh,07eh,03ch,07eh,0dbh,000h	; 166	
	db	000h,000h,03ch,066h,00ch,066h,03ch,000h	; 167	
	db	000h,000h,066h,06eh,07eh,076h,066h,000h	; 168	
	db	000h,018h,066h,06eh,07eh,076h,066h,000h	; 169	
	db	000h,000h,066h,06ch,078h,06ch,066h,000h	; 170	
	db	000h,000h,01eh,036h,066h,066h,066h,000h	; 171	
	db	000h,000h,0c6h,0feh,0feh,0d6h,0c6h,000h	; 172	
	db	000h,000h,066h,066h,07eh,066h,066h,000h	; 173	
	db	000h,000h,03ch,066h,066h,066h,03ch,000h	; 174	
	db	000h,000h,07eh,066h,066h,066h,066h,000h	; 175	

	db	092h,000h,092h,000h,092h,000h,092h,000h	; 176	
	db	092h,049h,092h,049h,092h,049h,092h,000h	; 177	
	db	0aah,055h,0aah,055h,0aah,055h,0aah,000h	; 178	
	db	018h,018h,018h,018h,018h,018h,018h,018h	; 179	
	db	018h,018h,018h,0f8h,018h,018h,018h,018h	; 180	
	db	018h,018h,0f8h,018h,0f8h,018h,018h,018h	; 181	
	db	06ch,06ch,06ch,0ech,06ch,06ch,06ch,06ch	; 182	
	db	000h,000h,000h,0fch,06ch,06ch,06ch,06ch	; 183	
	db	000h,000h,0f8h,018h,0f8h,018h,018h,018h	; 184	
	db	06ch,06ch,0ech,00ch,0ech,06ch,06ch,06ch	; 185	
	db	06ch,06ch,06ch,06ch,06ch,06ch,06ch,06ch	; 186	
	db	000h,000h,0fch,00ch,0ech,06ch,06ch,06ch	; 187	
	db	06ch,06ch,0ech,00ch,0fch,000h,000h,000h	; 188	
	db	06ch,06ch,06ch,0fch,000h,000h,000h,000h	; 189	
	db	018h,018h,0f8h,018h,0f8h,000h,000h,000h	; 190	
	db	000h,000h,000h,0f8h,018h,018h,018h,018h	; 191	

	db	018h,018h,018h,01fh,000h,000h,000h,000h	; 192	
	db	018h,018h,018h,0ffh,000h,000h,000h,000h	; 193	
	db	000h,000h,000h,0ffh,018h,018h,018h,018h	; 194	
	db	018h,018h,018h,01fh,018h,018h,018h,018h	; 195	
	db	000h,000h,000h,0ffh,000h,000h,000h,000h	; 196	
	db	018h,018h,018h,0ffh,018h,018h,018h,018h	; 197	
	db	018h,018h,01fh,018h,01fh,018h,018h,018h	; 198	
	db	06ch,06ch,06ch,06fh,06ch,06ch,06ch,06ch	; 199	
	db	06ch,06ch,06fh,060h,07fh,000h,000h,000h	; 200	
	db	000h,000h,07fh,060h,06fh,06ch,06ch,06ch	; 201	
	db	06ch,06ch,0efh,000h,0ffh,000h,000h,000h	; 202	
	db	000h,000h,0ffh,000h,0efh,06ch,06ch,06ch	; 203	
	db	06ch,06ch,06fh,060h,06fh,06ch,06ch,06ch	; 204	
	db	000h,000h,0ffh,000h,0ffh,000h,000h,000h	; 205	
	db	06ch,06ch,0efh,000h,0efh,06ch,06ch,06ch	; 206	
	db	018h,018h,0ffh,000h,0ffh,000h,000h,000h	; 207	

	db	06ch,06ch,06ch,0ffh,000h,000h,000h,000h	; 208	
	db	000h,000h,0ffh,000h,0ffh,018h,018h,018h	; 209	
	db	000h,000h,000h,0ffh,06ch,06ch,06ch,06ch	; 210	
	db	06ch,06ch,06ch,07fh,000h,000h,000h,000h	; 211	
	db	018h,018h,01fh,018h,01fh,000h,000h,000h	; 212	
	db	000h,000h,01fh,018h,01fh,018h,018h,018h	; 213	
	db	000h,000h,000h,07fh,06ch,06ch,06ch,06ch	; 214	
	db	06ch,06ch,06ch,0efh,06ch,06ch,06ch,06ch	; 215	
	db	018h,018h,0ffh,000h,0ffh,018h,018h,018h	; 216	
	db	018h,018h,018h,0f8h,000h,000h,000h,000h	; 217	
	db	000h,000h,000h,01fh,018h,018h,018h,018h	; 218	
	db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh	; 219	
	db	000h,000h,000h,000h,0ffh,0ffh,0ffh,0ffh	; 220	
	db	0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h	; 221	
	db	00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh	; 222	
	db	0ffh,0ffh,0ffh,0ffh,000h,000h,000h,000h	; 223	

	db	000h,000h,07ch,066h,066h,07ch,060h,000h	; 224	
	db	000h,000h,03ch,066h,060h,066h,03ch,000h	; 225	
	db	000h,000h,07eh,018h,018h,018h,018h,000h	; 226	
	db	000h,000h,066h,066h,03eh,006h,03ch,000h	; 227	
	db	000h,000h,07eh,0dbh,0dbh,07eh,018h,000h	; 228	
	db	000h,000h,066h,03ch,018h,03ch,066h,000h	; 229	
	db	000h,000h,066h,066h,066h,066h,07fh,003h	; 230	
	db	000h,000h,066h,066h,03eh,006h,006h,000h	; 231	
	db	000h,000h,0dbh,0dbh,0dbh,0dbh,0ffh,000h	; 232	
	db	000h,000h,0dbh,0dbh,0dbh,0dbh,0ffh,003h	; 233	
	db	000h,000h,0e0h,060h,07ch,066h,07ch,000h	; 234	
	db	000h,000h,0c6h,0c6h,0f6h,0deh,0f6h,000h	; 235	
	db	000h,000h,060h,060h,07ch,066h,07ch,000h	; 236	
	db	000h,000h,07ch,006h,03eh,006h,07ch,000h	; 237	
	db	000h,000h,0ceh,0dbh,0fbh,0dbh,0ceh,000h	; 238	
	db	000h,000h,03eh,066h,03eh,036h,066h,000h	; 239	

	db	066h,07eh,060h,07ch,060h,060h,07eh,000h	; 240	
	db	000h,066h,03ch,066h,07eh,060h,03ch,000h	; 241	
	db	000h,000h,000h,000h,003h,006h,00ch,018h	; 242	Little bottom Slash
	db	000h,000h,000h,000h,0c0h,060h,030h,018h	; 243	Little bottom BackSlash
	db	018h,030h,060h,0c0h,000h,000h,000h,000h	; 244	Little top Slash
	db	018h,00ch,006h,003h,000h,000h,000h,000h	; 245	Little top BackSlash
	db	000h,000h,018h,00ch,07eh,00ch,018h,000h	; 246	->
	db	000h,000h,018h,030h,07eh,030h,018h,000h	; 247	<-
	db	018h,03ch,07eh,018h,018h,018h,018h,000h	; 248	-^
	db	000h,000h,018h,03ch,03ch,018h,000h,000h	; 249	 NON_STANDARD-PREVIOUS-018h,018h,018h,018h,07eh,03ch,018h,000h ; 249 ; -v
	db	018h,018h,000h,07eh,000h,018h,018h,000h	; 250	-:-
	db	018h,018h,07eh,018h,018h,000h,07ch,000h	; 251	+-
	db	0cfh,0cch,0efh,0fch,0dch,0cch,0cch,000h	; 252	
	db	000h,066h,03ch,066h,066h,03ch,066h,000h	; 253	
	db	000h,000h,03ch,03ch,03ch,03ch,000h,000h	; 254	
	db	000h,000h,000h,000h,000h,000h,000h,000h	; 255

;;;GLEB <-

;**  Entry point after an hard reset
ColdStart:
	cli	

	OutDebug 0

;;;GLEB ->

;**  First of all we indicate that our firmware is working

	mov	bx, 3

.TestRead2:
	xor	cx, cx

.TestRead:
	in	al, 60h			; Check oscilloscope a read of port 60h (PIO 8255 CS, Pin 06) - must be nice LOW pulses
	loop	.TestRead
	dec	bx
	jnz	.TestRead2

;;;GLEB <-

;**  As very first we test the CPU
; Jump means error
	xor	ax,ax
	jb	ErrorCPU
	jo	ErrorCPU
	js	ErrorCPU
	jnz	ErrorCPU
	jpo	ErrorCPU

	add	ax,1
	jz	ErrorCPU
	jpe	ErrorCPU

	sub	ax,8002h
	js	ErrorCPU

	inc	ax
	jno	ErrorCPU

	shl	ax,1
	jnb	ErrorCPU
	jnz	ErrorCPU

	shl	ax,1
	jb	ErrorCPU

	xor	ax,ax
	jnz	ErrorCPU		; Jump if not zero

	add	al,80h
	jns	ErrorCPU		; Jump if not sign
	jc	ErrorCPU		; Jump if carry Set
	jp	ErrorCPU		; Jump if parity=1

	add	al,80h
	jnz	ErrorCPU		; Jump if not zero
	jno	ErrorCPU		; Jump if not overflw
	jnc	ErrorCPU		; Jump if carry=0

	lahf				; Load ah from flags
	or	ah,41h
	sahf				; Store ah into flags
	jnz	ErrorCPU		; Jump if not zero
	jnc	ErrorCPU		; Jump if carry=0

	cld				; Clear direction
	xor	si,si			; Zero register
	lodsb				; copy contents of [SI] into AL

	dec	si
	or	si,si			; SI = zero?
	jz	TestCPU1		; yes, -> continue test

; Error in the CPU found
ErrorCPU:
	OutDebug 80h

	cli
	hlt				; Halt processor


;**  Test CPU part 2: test the REGISTERS of the CPU
TestCPU1:
	OutDebug 1

	mov	bx,5555h
.L10:
	mov	bp,bx
	mov	cx,bp
	mov	sp,cx
	mov	dx,sp
	mov	ss,dx
	mov	si,ss
	mov	es,si
	mov	di,es
	mov	ds,di
	mov	ax,ds
	cmp	ax,5555h		; AX = 5555h?
	jnz	.L20			; no, -> 

	not	ax			; AX := 0AAAAh
	mov	bx,ax
	jmp	.L10

.L20:
	xor	ax,0AAAAh		; AX = 0AAAAh?
	jnz	ErrorCPU		; no, -> error


;**  Check the ROM by calculating its checksum
	OutDebug 2

	mov	cx,2000h
	
	mov	ax,cs
	mov	ds,ax			; DS := CS

	mov	bx,0E000h
	xor	al,al			; AL := zero

; Add the content of every byte in this ROM
.L30:
	add	al,[bx]
	inc	bx
	loop	.L30

	or	al,al			; result is zero?
	je	InitIO			; yes, -> OK

; No. Probably bad ROM or maybe hardware that cannot be trusted, so stop.
	OutDebug 81h

	cli
	hlt				; Halt processor


;**   Initialise the 8255 multi-port chip
InitIO:
	OutDebug 3

	mov	al,99h			; program 8255 PIA chip
	out	i8255Ctrl,al		;   Ports A & C, inputs

; Make sure that turbo is off and disable memory parity
	mov	al,0F8h
	out	i8255B,al


;**  Disable NMI interrupts
	xor	al,al
	out	NmiPort,al


;**  Enable the expansion unit
	mov	dx,0213h		; Expansion unit port
	out	dx,al


;;;GLEB ->

;**  Initialize the CGA character generator ...

InitCharGen:

	mov	ax, 0B800h		; ES-1841 CGA CharGen memory segment same as ES-1841 CGA Video memory segment
	mov	es, ax
	mov	al, 1
	mov	dx, 3DFh
	out	dx, al			; Switch from Video memory to CharGen memory (3DF = 1)
	mov	dx, 3D8h
	xor	al, al
	out	dx, al			; CharGen memory is accesible only when video is disabled (3D8 = 0)

	mov	si, Char_Gen		; CharGen source
	xor	di, di			; CharGen target
	mov	cx, 256*8		; CharGen size

.CharLoad:	
	mov	al, byte cs:[si]
	stosb				; Only byte access is allowed for CharGen memory
	inc	si
	loop	.CharLoad		; Load CharGen

	mov	al, 0
	mov	dx, 3DFh
	out	dx, al			; Switch from CharGen memory to Video memory (3DF = 0)
	mov	dx, 3D8h
	mov	al, 29h
	out	dx, al			; Enable Video

;**  Initialize the MDA character generator ...

 	mov	ax, 0DC00h		; ES-1841 MDA CharGen memory segment is DC00h
 	mov	es, ax
 	mov	dx, 3B8h
 	xor	ax, ax
 	out	dx, al			; CharGen memory is accesible only when video is disabled (3B8 = 0)

 	cld
 	xor	di, di
 	mov	cx, 1000h
 	rep	stosw			; Clear whole MDA CharGen RAM chip content (Really size of CharGen is less of)

	mov	si, Char_Gen		; CharGen source
 	xor	di, di			; CharGen target
 	mov	cx, 256			; CharGen size
 	xor	ax, ax			; Prepare AX for word exchange (ES-1841 MDA CharGen is 9 bits, high bit = 0 always)

.DoNextChar:
 	mov	bl, 8			; BL = counter of CharGen lines for one character (symbol)

.DoNextCharGenLine:	
	mov	al, byte cs:[si]	; Load byte, high part of AX already 0
 	inc	si
 	stosw				; Store AX in CharGen memory
 	dec	bl			; Decrement counter of CharGen lines for one character (symbol)
 	jnz	.DoNextCharGenLine	; Repeat until all CharGen lines for this character done

 	add	di, 16			; Target = next CharGen character position in CharGen RAM (word size)
 	loop	.DoNextChar

	mov	dx, 3B8h
	mov	al, 29h
	out	dx, al			; Enable Video

;;;GLEB <-

;**  Disable the CGA and MDA video system ...
	xor	al,al
	mov	dx,CGA_ctrl		; Color Graphic port
	out	dx,al			;   no video display

	inc	al			; AL := 1
	mov	dx,MDA_ctrl		; Monochrome port
	out	dx,al			;   no video display

; ... and initialise them both, no matter what card is present
	mov	ax,cs
	mov	ds,ax			; DS := CS
	mov	ss,ax			; SS := CS

	cld	

; Initialise the MDA port
	mov	dx,MDA_addr		; Monochrome port
	mov	si,Tbl_dataMDA
	mov	cx,16
	xor	bx,bx			; register counter
.L010:
	mov	al,bl
	out	dx,al			; output number of register

	lodsb				; read dat from table
	inc	dl
	out	dx,al			; output data

	dec	dl
	inc	bx
	loop	.L010


;**  Initialise the CGA port
	mov	dx,CGA_addr			; Color Graphic port
	mov	si,Tbl_dataCGA
	mov	cx,16
	xor	bx,bx			; register counter
.L020:
	mov	al,bl
	out	dx,al			; output number of register

	lodsb				; read dat from table
	inc	dx
	out	dx,al			; output data

	dec	dx
	inc	bx
	loop	.L020

	OutDebug 4

; Clear MDA screen
	mov	ax,SegmentMDA
	mov	es,ax

	mov	ax,0720h

	xor	di,di
	mov	cx,4096
	repz	stosw

; Set the correct mode
	mov	dx,MDA_ctrl
	mov	al,29h
	out	dx,al

; Clear CGA screen
	mov	ax,SegmentCGA
	mov	es,ax

	mov	ax,0720h

	xor	di,di
	mov	cx,4096
	repz	stosw

; Set the correct mode
	mov	dx,CGA_ctrl
	mov	al,29h
	out	dx,al

	inc	dx			; 3D9h = CGA palette register
	mov	al,30h
	out	dx,al

	OutDebug 5


;**  Make the cursor invisible
; For MDA
	mov	cx,2607h
	mov	ah,10			; 6845 register

	mov	al,ch			; Send ch, cl through CRT register ah

	mov	dx,3B4h			;   mono port

	xchg	al,ah
	out	dx,al			; send register number

	xchg	al,ah
	inc	dl
	out	dx,al			; send data byte for that register


	inc	ah			;   increment
	mov	al,cl			;   send cl

	mov	dx,3B4h			;   mono port
	xchg	al,ah
	out	dx,al			; send register number

	xchg	al,ah
	inc	dl
	out	dx,al			; send data byte for that register

; For CGA
	mov	cx,2607h
	mov	ah,10			; 6845 register

	mov	al,ch			; Send ch, cl through CRT register ah

	mov	dx,3D4h			;   CGA port

	xchg	al,ah
	out	dx,al			; send register number

	xchg	al,ah
	inc	dl
	out	dx,al			; send data byte for that register


	inc	ah			;   increment
	mov	al,cl			;   send cl

	mov	dx,3D4h			;   CGA port
	xchg	al,ah
	out	dx,al			; send register number

	xchg	al,ah
	inc	dl
	out	dx,al			; send data byte for that register

;**  Reserve the invisible part of the screen memory for the counters
; Invisible RAM =  4 KB - (visible screen + attributes)
;		   4096 -      (25 * 80 * 2)            = 96
CounterRAM:
	OutDebug 6

; Prepare the RAM for storage, first check if already done
	mov	ax,SegmentMDA		; MDA
.L10:
	mov	ds,ax
	mov	es,ax

; Set control word
	mov	ax,5C3Ah
	mov	[ControlWord],ax

; Clear (future) data holders
	xor	ax,ax			; AX := zero
	mov	di,InvScreenRAM+2
	mov	cx,47			; 47 words = 94 bytes
	rep	stosw
.L20:
	mov	ax,ds
	cmp	ax, SegmentMDA		; did we just check MDA?
	jne	DiagLoop		; no, -> was CGA, so continue with test

	mov	ax,SegmentCGA
	jmp	.L10

;**  Output the name of the program and the version
DiagLoop:
	OutDebug 7

	mov	ax,cs
	mov	ds,ax			; DS := CS
	mov	ss,ax			; SS := CS

	mov	sp,.L01
	mov	si,TxtVersion
	jmp	TextToScreen

.L01:
	dw .L02

.L02:

;;;GLEB ->
	mov	sp,.L01a
	mov	si,TxtVersion2
	jmp	TextToScreen

.L01a:
	dw .L02a

.L02a:
;;;GLEB <-

	mov	sp,TestCPU2
	mov	al,1
	jmp	Beeep


;**  We do the previous tests of the CPU and ROM again but now withe the 
;    according text. These tests are included in the loop, the previous ones
;    not. Begin FLAG test of CPU
TestCPU2:
	dw	.L04

.L04:
	OutDebug 8

	mov	sp,.L08
	mov	si,TxtTestCPU
	jmp	TextToScreen

.L08:
	dw	.L12

.L12:
	mov	sp,.L16
	jmp	ShowArrow

.L16:
	dw	.L20

.L20:
	OutDebug 9


;* Jump means error
	xor	ax,ax
	jb	ErrorCPU2
	jo	ErrorCPU2
	js	ErrorCPU2
	jnz	ErrorCPU2
	jpo	ErrorCPU2

	add	ax,1
	jz	ErrorCPU2
	jpe	ErrorCPU2

	sub	ax,8002h
	js	ErrorCPU2

	inc	ax
	jno	ErrorCPU2

	shl	ax,1
	jnb	ErrorCPU2
	jnz	ErrorCPU2

	shl	ax,1
	jb	ErrorCPU2

	xor	ax,ax
	jnz	ErrorCPU2		; Jump if not zero

	add	al,80h
	jns	ErrorCPU2		; Jump if not sign
	jc	ErrorCPU2		; Jump if carry Set
	jp	ErrorCPU2		; Jump if parity=1

	add	al,80h
	jnz	ErrorCPU2		; Jump if not zero
	jno	ErrorCPU2		; Jump if not overflw
	jnc	ErrorCPU2		; Jump if carry=0

	lahf				; Load ah from flags
	or	ah,41h
	sahf				; Store ah into flags
	jnz	ErrorCPU2		; Jump if not zero
	jnc	ErrorCPU2		; Jump if carry=0

	cld				; Clear direction
	xor	si,si			; Zero register
	lodsb				; copy contents of [SI] into AL

	dec	si
	or	si,si			; SI = zero?
	jz	TestCPU4		; yes, -> continue test

; Error in the CPU found
ErrorCPU2:
	OutDebug 82h

	mov	sp,.L10
	mov	si,TxtTestCPU
	jmp	DispCritical

.L10:
	dw .L20

.L20:
	mov	al,82h

; IMHO it makes no sense to continue the test with a bad CPU
HaltCPU:
%ifndef SoundDebug
	cli
	hlt				; Halt processor
%else
.L10:
	mov	al,1
	mov	sp,.L20
	jmp	Beeep

.L20:
	dw .L10				; just loop to produce a continous beep
%endif


;**  Test CPU part 2: test the REGISTERS of the CPU
TestCPU4:
	OutDebug 10

	mov	bx,5555h
.L10:
	mov	bp,bx
	mov	cx,bp
	mov	sp,cx
	mov	dx,sp
	mov	ss,dx
	mov	si,ss
	mov	es,si
	mov	di,es
	mov	ds,di
	mov	ax,ds
	cmp	ax,5555h		; AX = 5555h?
	jnz	.L20			; no, -> 

	not	ax			; AX := 0AAAAh
	mov	bx,ax
	jmp	.L10

.L20:
	xor	ax,0AAAAh		; AX = 0AAAAh?
	jnz	ErrorCPU2		; no, -> error

; Set SS again, has been changed here above
	mov	ax,cs
	mov	ss,ax			; SS := CS

	mov	sp,.L30
	mov	si,TxtTestCPU
	jmp	DisplayPassed

.L30:
	dw	.L40

.L40:
	mov	sp,ChecksumROM
	mov	si,TxtTestCPU
	jmp	RemoveArrow


;**  Check the ROM by calculating its checksum
ChecksumROM:
	dw .L08

.L08:
	OutDebug 12

	mov	sp,.L10
	mov	si,TxtChecksumROM
	jmp	TextToScreen

.L10:
	dw .L12

.L12:
	mov	sp,.L14
	jmp	ShowArrow

.L14:
	dw .L20

.L20:
	OutDebug 14

	mov	cx,2000h
	
	mov	ax,cs
	mov	ds,ax			; DS := CS

	mov	bx,0E000h
	xor	al,al			; AL := zero

; Add the content of every byte in this ROM
.L30:
	add	al,[bx]
	inc	bx
	loop	.L30

	or	al,al			; result is zero?
	je	.L40			; yes, -> OK

; No. Probably bad ROM or maybe hardware that cannot be trusted, so stop.
	OutDebug 83h

	mov	sp,.L33
	mov	si,TxtChecksumROM
	jmp	DispCritical

.L33:
	dw .L34

.L34:
	mov	al,83h
	jmp	HaltCPU


.L40:
	mov	sp,.L97
	mov	si,TxtChecksumROM
	jmp	DisplayPassed

.L97:
	dw	.L98

.L98:
	mov	sp,.L99
	mov	si,TxtChecksumROM
	jmp	RemoveArrow

.L99:
	dw CheckTimers


;**  Check the 8253 timer
CheckTimers:
	OutDebug 18

	mov	sp, .L12
	mov	si,Txt8253Ch0
	jmp	TextToScreen

.L12:
	dw .L14

.L14:
	mov	sp,.L16
	jmp	ShowArrow

.L16:
	dw .L18

.L18:
	OutDebug 20

	mov	al,4
	out	DMA8237+8,al		; disable the DMA controller

; Disable the speakers and enable timer 2
	in	al,i8255B
	or	al,1
	and	al,0FDh
	out	i8255B, al


	OutDebug 22

	mov	dx,0040h		; check counter 0


;**  Common routine for checking the channels of the 8253 timer
; in:	DX = address of channel
Check8253:
	mov	ax,dx			; AX := address of channel to be tested
	and	al,3			; we only need the first two bits
	ror	al,1
	ror	al,1			; bit 1..0 -> bits 7..6 = counter
 
	mov	ah,al			; save counter bits
	or	al,34h			; read/write counter bits 0-7 first,
					;    then 8-15
					; mode 2 select - rate generator
	out	43h,al

	xor	cx,cx			; CX := zero
	mov	bx,cx
	
	mov	al,cl			; AL := zero
	out	dx,al			; write bits 0..7

	nop
	nop

	out	dx,al			; write bits 8..15

	mov	di,4
.L20:
	nop
	nop

	mov	al,ah			; AL := counter
	out	43h,al			; latch command

	nop
	nop

	in	al,dx			; read counter bits 0..7
	or	bl,al			; save read value

	nop
	nop

	in	al,dx			; read counter bits 8..15
	or	bh,al
	cmp	bx,byte -01h		; result is OK?
	je	.L30			; yes, -> 

	loop	.L20			; another try ->

	dec	di			; another try?
	jne	.L20			; yes, -> 

; No, we have an error
	jmp	Error8253

.L30:
	mov	bx,0FFFFh
.L40:
	mov	al,ah			; AH = counter
	out	43h,al

	nop
	nop

	in	al,dx
	and	bl,al

	nop
	nop

	in	al,dx
	and	bh,al
	and	bx,bx			; result is OK?
	je	NoError8253		; yes, -> 

	loop	.L40			; another try ->

; Again, we found an error
	jmp	Error8253


; We found no errors, go to next counter or test
NoError8253:
	mov	si,dx
	and	si,3
	shl	si,1
	jmp	word [cs:si+.L10]

.L10:
	dw Check8253Ch0P
	dw Check8253Ch1P
	dw Check8253Ch2P


; Channel 0 passed the test
Check8253Ch0P:
	mov	sp,Check8253Ch0C
	mov	si,Txt8253Ch0
	jmp	DisplayPassed


Check8253Ch0C:
	dw	.L98

.L98:
	mov	sp,.L99
	mov	si,Txt8253Ch0
	jmp	RemoveArrow

.L99:
	dw Check8253Ch1


;**  Prepare for testing channel 1 of the 8253 timer
Check8253Ch1:
	mov	sp,.L96
	mov	si,Txt8253Ch1
	jmp	TextToScreen

.L96:
	dw	.L97

.L97:
	mov	sp,.L98
	jmp	ShowArrow

.L98:
	dw .L99

.L99:
	OutDebug 24

	mov	dx,0041h
	jmp	Check8253

 
; Channel 1 passed the test
Check8253Ch1P:
	mov	sp,Check8253Ch1C
	mov	si,Txt8253Ch1
	jmp	DisplayPassed

Check8253Ch1C:
	dw	.L98

.L98:
	mov	sp,.L99
	mov	si,Txt8253Ch1
	jmp	RemoveArrow

.L99:
	dw Check8253Ch2


;**  Prepare for testing channel 2 of the 8253 timer
Check8253Ch2:
	mov	sp,.L96
	mov	si,Txt8253Ch2
	jmp	TextToScreen

.L96:
	dw	.L97

.L97:
	mov	sp,.L98
	jmp	ShowArrow

.L98:
	dw .L99

.L99:
	OutDebug 26

	mov	dx,0042h
	jmp	Check8253


; Channel 2 passed the test
Check8253Ch2P:
	mov	sp,Check8253Ch2C
	mov	si,Txt8253Ch2
	jmp	DisplayPassed

Check8253Ch2C:
	dw	.L98

.L98:
	mov	sp,.L99
	mov	si,Txt8253Ch2
	jmp	RemoveArrow

.L99:
	dw	Check8237DMA


; We found an error, display FAILED and go to the next counter or test
Error8253:
	mov	si,dx
	and	si,3
	shl	si,1
	jmp	word [cs:si+.L10]

.L10:
	dw Check8253Ch0E
	dw Check8253Ch1E
	dw Check8253Ch2E


Check8253Ch0E:
	OutDebug 84h

	MacFailed	Txt8253Ch0,Err8253Ch0,Check8253Ch0C


Check8253Ch1E:
	OutDebug 86h

	MacFailed	Txt8253Ch1,Err8253Ch1,Check8253Ch1C


Check8253Ch2E:
	OutDebug 88h

	MacFailed	Txt8253Ch2,Err8253Ch2,Check8253Ch2C


;**  Test the 8237 DMA chip
Check8237DMA:
	OutDebug 28

	mov	sp,.L02
	mov	si,Txt8237DMA
	jmp	TextToScreen

.L02:
	dw	.L04

.L04:
	mov	sp,.L06
	jmp	ShowArrow

.L06:
	dw .L08

.L08:
	OutDebug 30

	mov	al,0
	out	DMA8237+0Dh,al		; stop all DMA activities

	nop
	nop
	nop

	out	DMA8237+8,al

	mov	ax,0FF00h
	mov	di,0001h

; Test with value in AX
.L10:
	xor	dx,dx
	mov	cx,0008h

; First fill registers 0..7 with value in AL
.L20:
	out	dx,al

	nop
	nop
	nop

	out	dx,al

	inc	dx
	loop	.L20

	xor	si,si

	xchg	ah,al
	mov	bx,ax

; Now test with value that was original in AH
.L24:
	mov	dx,si
	out	dx,al

	nop
	nop
	nop

	out	dx,al

	mov	cx,0008h
	xor	dx,dx
.L28:
	cmp	dx,si			; DX = SI?
	je	.L36			; yes, ->

	in	al,dx
	cmp	al,bh			; same as the original value?
	je	.L32			; yes, -> = OK, continue

	jmp	DmaError

.L32:
	in	al,dx
	cmp	al,bh			; same as the original value?
	je	.L40			; yes, -> = OK, continue

	jmp	DmaError

 .L36:
	in	al,dx
	cmp	al,bl			; same as the original value?
	jne	DmaError		; no, -> error

	in	al,dx
	cmp	al,bl			; same as the original value?
	jne	DmaError		; no, -> error

.L40:
	inc	dx
	loop	.L28

	OutDebug 34

	mov	dx,si

	mov	al,bh
	out	dx,al

	nop
	nop
	nop

	out	dx,al

	mov	ax,bx
	inc	si
	cmp	si,8			; we tested all eight registers?
	je	.L44			; yes, -> next phase

	jmp	.L24			; next register

.L44:
	mov	ax,00FFh
	dec	di			; did we test with 00FFh already?
	je	.L10			; no, -> test again with new value

	in	al,08h

	nop
	nop
	nop

	in	al,08h
	test	al,0Fh			; low nible all zero?
	je	DmaOK			; yes, -> 

DmaError:
	OutDebug 8Ah

	mov	sp,.L10
	mov	si,Txt8237DMA
	jmp	DispCritical
; Without DMA the memory cannot be refreshed and therefore I halt the test.

.L10:
	dw .L20

.L20:
	mov	al,8Ah
	jmp	HaltCPU
	

DmaOK:
	mov	sp,.L98
	mov	si,Txt8237DMA
	jmp	DisplayPassed

.L98:
	dw	.L99

.L99:
	mov	sp,InitRefresh0
	mov	si,Txt8237DMA
	jmp	RemoveArrow

;**  Init the DMA and 8253 so the DRAM will be refreshed from now on
InitRefresh0:
	dw InitRefresh

InitRefresh:

;;;GLEB ->

;**  Init the main RAM Board for ES-1841

 	in	al, 61h
 	and	al, 0CFh		; 1100 1111 => clear bit5 (i/o ch err off), bit4 (ram err off)
 	out	61h, al

 	mov	dx, 2B0h
;;;GLEB 	in	al, dx
;;;GLEB		and	al, 0Ch
;;;GLEB 	cmp	al, 0Ch
;;;GLEB		jz	ca1
;;;GLEB 	mov	bx, res_fl
;;;GLEBca1:	
;;;GLEB		mov	al, 0Ah
;;;GLEB		out	dx, al
;;;GLEB 	in	al, dx
;;;GLEB 	and	al, 0Fh
;;;GLEB 	cmp	al, 0Ah
;;;GLEB 	jnz	oshp	   	; 2B0 Board missed
 	mov	al, 0Ch
 	out	dx, al			; XXXX 1100 => Read/Write access enable (2 hi bits = 1), no bank reconfig (2 lo bits = 0)

 	xor	al, al  		; Disable all other (Extended/Expanded) RAM boards (2B1, 2B2, 2B3)
ca2:	
	inc	dx
 	out	dx, al
 	cmp	dl, 0B3h
 	jnz	ca2

;;;GLEB <-

	OutDebug 36

 	mov	al,0	 		; Disable NMI ;;;GLEB
 	out	83h,al			; Init DMA cannel 3 Page register ;;;GLEB

	mov	al, 7	;;;GLEB xor	al,al
	out	DMA8237+0Dh,al		; stop DMA on 8237 chip

	nop
	mov	al,58h			; refresh auto-init dummy read
	out	DMA8237+0Bh,al		;   on channel 0 of DMA chip

	nop
	mov	al,41h			; block verify
	out	DMA8237+0Bh,al		;   on channel 1 of DMA chip

	nop
	inc	al
	out	DMA8237+0Bh,al		;   on channel 2 of DMA chip

	nop
	inc	al
	out	DMA8237+0Bh,al		;   on channel 3 of DMA chip

	nop
	mov	al,0FFh			; refresh byte count with 0FFh
	out	DMA8237+1,al

	nop
	nop
	nop

	out	DMA8237+1,al

	nop
	inc	al
	out	DMA8237+0Ah,al		; enable DMA on all channels

	nop
	nop
	nop

	out	DMA8237+8,al		; initialize 8237 command reg with zero

; Set the 8253 timer as needed
	mov	al,54h			; IC 8253 inits memory refresh
	out	PIT8253Ctrl,al		;   chan 1 pulses IC 8237 to

	mov	al,7	;;;GLEB	12h			; DMA every 12h clock ticks
	out	PIT8253B,al		;   64K done in 1 millisecond


;**  Check for parity errors
	OutDebug 38

	mov	si,Txt8255Parity
	mov	sp,Check8255Par0
	jmp	TextToScreen

Check8255Par0:
	dw .L14

.L14:
	mov	sp,.L16
	jmp	ShowArrow

.L16:
	dw Check8255Par


Check8255Par:

; Disable memory parity
	OutDebug 40

	mov	dx,i8255B
	in	al,dx
	or	al,30h
	out	dx,al

; Delay
	xor	cx,cx
.L10:
	loop	.L10
.L12:
	loop	.L12

	mov	sp,.L96
	mov	si,Txt8255Parity

	in	al,i8255C
	test	al,0C0h			; parity error found?
	jne	.L20			; yes, -> 

	jmp	DisplayPassed

.L20:
	OutDebug 8Ch

	MacFailed	Txt8255Parity,Err8255Parity,.L96

.L96:
	dw	.L97

.L97:
	mov	sp,.L98
	mov	si,Txt8255Parity
	jmp	RemoveArrow

.L98:
	dw Check2KbRAM


;**  Check the first two KB of memory. We need this for the stack
Check2KbRAM:
	OutDebug 42

	mov	sp,.L00
	mov	si,TxtChk2KbRAM
	jmp	TextToScreen

.L00:
	dw .L01

.L01:
	mov	sp,.L02
	jmp	ShowArrow

.L02:
	dw .L03

.L03:
	cld	

; Enable memory parity
	OutDebug 46

	in	al,61h
	and	al,0CFh
	out	61h,al

; Clear 2 KB of memory
	xor	ax,ax
	mov	es,ax
	mov	ds,ax

	mov	di,ax
	mov	si,ax

	mov	cx,0400h		; 1024 words = 2048 bytes = 2 KB
	repz	stosw

	mov	cx,0400h
	rep	lodsw

	mov	ax,0FF7Fh
	xor	di,di
	mov	cx,0400h
	repz	stosw

	xor	si,si
	mov	cx,0400h
	rep	lodsw

; Toggle memory parity to clear possible errors caused by the above action
	in	al,61h
	or	al,30h			; clear parity
	out	61h,al

	nop
	nop

	and	al,0CFh			;  and enable it again
	out	61h,al

; Prepare for the actual check
	xor	ax,ax
	mov	es,ax			; very first segment

	mov	cx,0800h		; check 2 KB of RAM
	mov	sp,.L04
	jmp	CheckMemory	

.L04:
	dw .L05

.L05:
	mov	si,TxtChk2KbRAM
	jc	.L10			; if error found, ->

	mov	sp,.L96
	jmp	DisplayPassed

.L10:
	OutDebug 8Eh

	mov	sp,.L15
	jmp	DispCritical
; Note: The rest of the routines use subroutines, which means I need good
;	working RAM. If that is not present, I better can stop. A PC wouldn't
;	work as well so why should we continue? :)

.L15:
	dw .L20

.L20:
	mov	al,8Eh
	jmp	HaltCPU
	

.L96:
	dw	.L97

.L97:
	OutDebug 48

	mov	sp,.L98
	mov	si,TxtChk2KbRAM
	jmp	RemoveArrow

.L98:
	dw	CheckAllRAM


;**  Check all RAM until 640 KB or less in chunks of 1 KB
CheckAllRAM:
	xor	ax,ax
	mov	ss,ax			; stack segment := first segment
	mov	sp,05FFh		; set stack pointer

	OutDebugB 50

	mov	si,TxtChkAllRAM
	call	TextToScreen
	call	ShowArrow

	mov	bp,80h			; BP = KB counter, start with 3rd KB
.L10:
	mov	es,bp
	mov	cx,0400h		; test a block of 1 KB
	call	CheckMemory		; error?
	jc	.L80			; yes, ->

; No error found, display amount in decimal numbers
	OutDebugB 52

	add	bp,40h			; increment counter
	mov	dx,3030h		; hundreds and tens

	mov	ax,bp
	mov	cl,6
	shr	ax,cl			; AX := AX div 64 = number of KB
.L20:
	cmp	ax,100			; smaller than 99?
	jb	.L30			; yes, ->

	inc	dh
	sub	ax,100			; subtract 100
	jmp	.L20			; another check for hundreds

.L30:
	cmp	ax,10			; smaller than 9?
	jb	.L40			; yes, ->

	inc	dl
	sub	ax,10			; subtract 10
	jmp	.L30			; another check for tens

;* Display results
.L40:
	or	al,30h			; number -> ASCII
	mov	bl,al			; save AL

; Locate the spot on the screen where to display the results
	mov	si,TxtChkAllRAM
	mov	di,13			; position on the line
	call	CalcSpotScreen

	call	DisplayValue

	cmp	bp,0A000h		; 640 KB?
	jb	.L10			; no, ->

	mov	si,TxtNoMemError
	call	TextToScreen

	mov	si,TxtChkAllRAM
	call	RemoveArrow

	jmp	CheckPIC8259


;**  Bad memory, parity error or less than 640 KB found
; in:	AH = original value
;	DI = pointer within the tested 1 KB of memory
;	ES = current 1 KB segment
; Note:	My idea of "no memory" is that after a test 3 or more bits don't match.
;	I won't check for "good" memory further on to see if other banks are
;	OK again. This is because the hardware can range from 64 KB banks only,
;	a combination of 256 KB plus 64 KB banks or just one 1 MB SIM. IMHO it
;	is up to the user how to interprete the given information.
.L80:
	OutDebugB 54

	mov	ax,5555h
.L81:
	xor	cx,cx
	mov	[es:di],al		; write test value ...
.L82:
	loop	.L82

	mov	al,[es:di]		; ... and read it again after a delay
	xor	al,ah			; find the difference

	cmp	ah,55h			; did we do a second test?
	jne	.L83			; yes, -> 

	mov	bh,al			; save result
	mov	ax,0AAAAh
	jmp	.L81

.L83:
	or	bh,al			; combine results
; Note:	at this point I expect BH to be not zero. If it is, then what went
;	wrong with the original test?

	OutDebugB 56

	xor	ah,ah			; clear counter
	mov	cx,8			; 8 shifts needed
	mov	al,bh			; make a copy
	clc
.L84:
	shr	al,1			; shift bit 0 into Carry, set?
	jnc	.L85			; no, -> skip count

	inc	ah			; increment counter
.L85:
	loop	.L84

	push	ax			; save counter

	call	ES2DEC			; DH/DL/BL contains decimal # of KBs

	pop	ax			; restore counter

	push	bx			; save bad bit pattern / ones
	push	dx			; save hundreds and tens

	cmp	ah,3			; more than 3 bits?
	ja	.L92			; yes, -> consider it as "no memory" 

; Bad memory found
	OutDebugB 58

	mov	si,TxtBadMemory
	call	TextToScreen

	mov	si,TxtBadMemory
	mov	di,13			; position on the line
.L86:

;;;GLEB ->

; Show BAD bits

; (*) This message does not necessarily indicate a memory error.
; Different configurations of the EC-1841 offer varying amounts of memory, mostly 640KB and 512KB, 
; but in rare (possibly unofficial) cases, you can also find 128KB, 256KB, and 384KB options.
; Since the software cannot know the true configuration of the installed memory cards, this message 
; is displayed whenever less than 640KB of memory is detected. Additionally, information about the 
; byte located immediately after the detected end of memory is displayed.
; If there is at least one correct bit in this byte, then the memory exists beyond the detected 
; "end of memory", but a failure has occurred in it. If all the bits are wrong, then the memory is 
; really no more, or it is so faulty that it is not detected at all.

;;;GLEB <-

	call	CalcSpotScreen
	push	di			; save place on screen

	mov	si,TxtBadBits
	call	TextToScreen

	pop	di			; restore place on screen
	pop	dx			; restore hundreds and tens
	pop	bx			; restore bad bit pattern / ones

	call	DisplayValue		; Out DH/DL/BL to screen position DI ;;;GLEB

; SI = TxtBadBits / TxtEndOfMemory, display individual bad bits
	mov	di,80+11		; position on the line
	call	CalcSpotScreen

	mov	cx,8
.L87:
	shl	bh,1			; bit is set?
	jnc	.L88			; no, -> 

	mov	ax,7000h+'X'
	jmp	.L89

.L88:
	mov	ax,0700h+'0'
.L89:
	mov	[es:di],ax		; write result MDA
	add	di,8000h
	mov	[es:di],ax		; write result CGA
	sub	di,7FFCh		; back to MDA and skip space
	loop	.L87

	add	di,2			; skip space

	in	al,i8255C
	test	al,0C0h			; parity error?
	jne	.L90			; yes, ->

	mov	ax,0700h+'O'
	jmp	.L91

.L90:
	mov	ax,7000h+'X'
.L91:
	mov	[es:di],ax		; write result MDA
	add	di,8000h
	mov	[es:di],ax		; write result CGA

	mov	si,TxtChkAllRAM
	call	RemoveArrow

	jmp	CheckPIC8259


; End of memory < 640 KB found
.L92:
	OutDebugB 60

	mov	si,TxtEndOfMemory
	call	TextToScreen

; SI = TxtEndOfMemory
	mov	di,17			; KB position inside message ;;;GLEB
	jmp	.L86


;**  Check the 8259 Programmable Interrupt Controller (PIC)
CheckPIC8259:
	mov	si,TxtPIC8259
	call	TextToScreenA

	OutDebugB 62

; Init the 8259
	mov	al,13h			; ICW1 = 
					;  ICW4 needed, single 8259, call
	out	PIC8259,al		;  address interval = 8, edge triggered

	nop
	nop

	mov	al,8			; ICW2 = IRQs start at INT 8
	out	PIC8259+1,al		;   INT 8 = 0000:0020h

	nop
	nop

	mov	al,9			; ICW4 = 
	out	PIC8259+1,al		; non-buffered, normal EOI, 8086 mode

	nop
	nop

; Check the In Service Register (ISR)
	mov	al,0Bh			; OCW3 =
	out	PIC8259,al		;  read IS register on next RD pulse

	in	al,PIC8259		; should be zero
	and	al,al			; is it?
	jne	.L10			; no, -> error

; Check the Interrupt Enable Register
	out	PIC8259+1,al		; AL = zero

	nop
	nop

	in	al,PIC8259+1		; should be zero
	and	al,al			; is it?
	jne	.L10			; no, -> error

	dec	al			; AL := 0FFh
	out	PIC8259+1,al		;  also disable all interrupts

	nop
	nop

	in	al,PIC8259+1		; should be 0FFh
	cmp	al,0FFh			; is it?
	je	L8259OK			; yes, -> 

; Error found in 8259
.L10:
	OutDebugB 90h

	mov	bx,Err8259PIC
	call	DisplayFailedA

	jmp	CheckBadIRQ


; 8259 is OK
L8259OK:
	call	DisplayPassedA


;**  Generate a real interrupt and check the reaction of the 8259 
CheckBadIRQ:
	OutDebugB 64

	mov	si,TxtCheckBadIRQ
	call	TextToScreenA

; Fill the range for INT 8..15 with a vector to the routine RealINT
	xor	ax,ax
	mov	es,ax			; ES := first segment

	mov	di,0020h		; start at ES:0020h
	mov	cx,0008h
.L10:
	mov	ax,RealINT
	stosw

	mov	ax,cs
	stosw

	loop	.L10

	xor	ah,ah			; clear check byte
	sti				; enable interrupts

; Delay
.L20:
	loop	.L20
.L30:
	loop	.L30

	cli				; disable interrupts
	or	ah,ah			; did any interrupt occur?
	jne	.L80			; yes, -> error
; Note: AH contains the number of the bad interrupt. Future use maybe?

	call	DisplayPassedA
	jmp	CheckINT0

.L80:
	OutDebugB 92h

	mov	bx,ErrBadIRQ
	call	DisplayFailedA


;**  Check if INT0 is recognised = timer interrupt
CheckINT0:
	OutDebugB 66

	mov	si,TxtCheckINT0
	call	TextToScreenA

	mov	ax,00FEh		; clear counter and
	out	PIC8259+1,al		;  only ensable timer interrupt

	mov	al,10h			; select timer 0, LSB, mode 0, binary
	out	PIT8253Ctrl,al

	mov	ax,24
	out	PIT8253A,al

	mov	cx,ax

	sti	
.L10:
	or	ah,ah			; did an interrupt occur?
	jne	.L30			; yes, -> is good

	loop	.L10

; No interrupt occurred = error
.L20:
	OutDebugB 94h

	mov	bx,ErrINT0
	call	DisplayFailedA
	jmp	CheckNMI


; Interrupt occurred = OK
.L30:
	OutDebugB 68

	cli				; disable interrupts
	mov	cl,20

	mov	al,0FFh			; set timer
	out	PIT8253A,al

	mov	ax,00FEh		; clear counter and
	out	PIC8259+1,al		;  reensable timer interrupt

	sti
.L40:
	or	ah,ah			; did an interrupt occur?
	jne	.L20			; yes, -> 

	loop	.L40

; No interrupt occurred = OK
.L50:
	cli				; disable interrupts

	call	DisplayPassedA


;**  Check the non maskable interrupt
CheckNMI:
	cli				; disable interrupts

	OutDebugB 70

	mov	si,TxtCheckNMI
	call	TextToScreenA

	xor	ax,ax
	mov	es,ax

	mov	di,0008h

	mov	ax,RealNMI
	stosw

	mov	ax,cs
	stosw

	xor	ah,ah

; Disable memory parity
	mov	dx,i8255B
	in	al,dx
	or	al,30h
	out	dx,al

	mov	al,80h
	out	0A0h,al			; enable NMI

; Delay
	xor	cx,cx
.L10:
	loop	.L10
.L12:
	loop	.L12
.L14:
	loop	.L14

	xor	al,al
	out	NmiPort,al		; disable NMI interrupts

	or	ah,ah			; interrupt found?
	je	.L20			; no, -> continue

; Found one = error
	OutDebugB 96h

	mov	bx,ErrNMI
	call	DisplayFailedA
	jmp	CheckScrMemory

.L20:
	call	DisplayPassedA


;**  Check the screen memory of the video card (if present)
CheckScrMemory:
	OutDebugB 72

	mov	si,TxtCheckMDA
	call	TextToScreenA

	mov	dx,MDA_addr
.L04:
	push	dx

	mov	al,14			; HB cursor locaion
	out	dx,al

	inc	dx
	in	al,dx			; read register
	mov	bl,al			;  and save it

	xor	al,al			; AL := zero
	out	dx,al

	nop

	in	al,dx			; read it again
	or	al,al			; still zero?
	jne	.L10			; no, -> error

	mov	al,5
	out	dx,al			; save another test value

	nop

	in	al,dx			;  and read it again
	cmp	al,5			; the same?
	je	.L20			; yes, -> OK

; Display the "FAILED" message
.L10:
	pop	ax			; get I/O address
	push	ax			; and save it again

	cmp	ax,MDA_addr		; MDA?
	jne	.L12			; no, -> CGA

	mov	bx,ErrMemoryMDA
	mov	si,TxtCheckMDA
	jmp	.L14

.L12:
	mov	bx,ErrMemoryCGA
	mov	si,TxtCheckCGA
.L14:
	OutDebugB 96h

	call	DisplayFailedA

	pop	ax			; get I/O address
	cmp	ax,MDA_addr		; MDA?
	jne	.L16			; no, -> was CGA, next test

	jmp	.L58			; do CGA

.L16:
	jmp	Check8087


; 6845 found, restore register 14
.L20:
	mov	al,bl
	out	dx,al

; Now check the first two words
	pop	ax
	push	ax

	cmp	ax,MDA_addr		; MDA?
	jne	.L22			; no, -> CGA

	mov	ax,SegmentMDA		; MDA memory
	jmp	.L24

.L22:
	mov	ax,SegmentCGA		; CGA memory
.L24:
	mov	ds,ax
	mov	es,ax

	xor	si,si

; Save original content
	lodsw
	mov	bx,ax

	lodsw
	mov	cx,ax

; Write two test words
	mov	bp,5555h

; Reset pointers
.L30:
	xor	di,di
	xor	si,si

	mov	ax,bp
	stosw
	stosw

; And test the words
	lodsw
	cmp	ax,bp
	jne	.L10

	lodsw
	cmp	ax,bp
	jne	.L10

	cmp	bp,5555h		; only first test?
	jne	.L40			; no, ->

	not	bp			; BP := 0AAAAh
	jmp	.L30

; Restore original content
.L40:
	xor	di,di

	mov	ax,bx
	stosw

	mov	ax,cx
	stosw

;* Two words have been found OK, check the whole 80*25 words
; Note:	MDA has 4 KB = 4096 bytes and CGA 32 KB of RAM. Idea: use some RAM
;	beyond the 2000 bytes needed for the screen to save counters etc.

; Make a copy of the screen to the normal memory
	cld				; direction := upwards
.L50:
	mov	ax,0080h
	mov	es,ax			; destination segment

; Source segmnt has already been set but save its value now
	mov	dx,ds

	xor	di,di
	xor	si,si

	mov	cx,2010			; 80*25 + 10 words
	rep	movsw

; Now fill it with test values
	mov	bp,0AAAAh
	mov	es,dx			; destination segment := MDA/CGA screen
.L52:
	xor	di,di
	xor	si,si

	mov	cx,2010			; 80*25 + 10 words
	mov	ax,bp
	rep	stosw

; Delay
.L53:
	loop	.L53

; Test the written value
	mov	cx,2010			; 80*25 + 10 words
.L54:
	lodsw
	cmp	ax,bp			; same value?
	jne	.L10			; no, -> error

	loop	.L54

	cmp	bp,0AAAAh		; second test has been done?
	jne	.L56			; yes, ->

	not	bp
	jmp	.L52

; Restore the screen
.L56:
	mov	ax,0080h
	mov	ds,ax			; source segment

	xor	di,di
	xor	si,si

	mov	cx,2010			; 80*25 + 10 words
	rep	movsw

	pop	dx
	cmp	dx,MDA_addr		; CGA has been tested?
	jne	.L90			; yes, ->

	mov	si,TxtCheckMDA
	call	DisplayPassedA
.L58:
	OutDebugB 74

	mov	si,TxtCheckCGA
	call	TextToScreenA

	mov	dx,CGA_addr
	jmp	.L04

.L90:
	mov	si,TxtCheckCGA
	call	DisplayPassedA


;**  Looking for (##### and checking) the 8087 coprocessor
Check8087:
	OutDebugB 76

	mov	si,TxtCheck8087
	call	TextToScreenA
 
	xor	ax,ax
	mov	ds,ax			; first segment

	fninit				; try to init FPU

	mov	bx,0420h
	mov	[bx],ax			; clear memory byte
.wait:
	loop 	.wait 			; wait for coprocessor to initialize

	fnstcw	[bx]			; put control word in memory

	mov	ax,[bx]
	cmp	ax,03FFh		; 8087 present?
	jne	.L10			; no, ->

	mov	si,TxtCheck8087
	call	DisplayPassedA
	jmp	CheckKeyboard

.L10:
	OutDebugB 98h

	mov	bx,Err8087
	mov	si,TxtCheck8087
	call	DisplayFailedA


;**  Check if a keyboard is present
CheckKeyboard:
	OutDebugB 78

	mov	si,TxtChkKeybCont
	call	TextToScreenA

	in	al,i8255A		; clear buffer

; Enable the keyboard
	mov	al,0Ch			; set keyboard CLK line low
	out	i8255B,al

; Delay
	xor	cx,cx
.L04:
	loop	.L04

	mov	al,0CCh			; set CLK, enable lines high
	out	i8255B,al

	nop
	nop

	mov	al,4Ch			; keyboard CLK high, enable low
	out	i8255B,al

; Now wait for an interrupt
	mov	al,0FDh
	out	PIC8259+1,al		; enable keyboard interrupt

	sti	

	call	CheckForINT		; has there been an interrupt?
	jne	.L20			; yes, -> OK
.L10:
	OutDebugB 9Ah

	mov	bx,ErrKeybCntr
	call	DisplayFailedA
	jmp	.L30

.L20:
	in	al,i8255A		; read value
	cmp	al,0AAh			; correct init code?
	jne	.L10			; no, -> error

	call	DisplayPassedA


; Disable all interrupts
.L30:
	mov	al,0FFh
	out	PIC8259+1,al

	cli


;**  Scan the keyboard for not expected output
CheckKeybScan:
	OutDebugB 80

	mov	si,TxtChkKeybScan
	call	TextToScreenA

; Disable the keyboard
	mov	al,0F8h
	out	i8255B,al

	nop
	nop

	mov	al,78h
	out	i8255B,al

	mov	al,0FDh
	out	PIC8259+1,al		; enable keyboard interrupt

; Now wait for an interrupt
	call	CheckForINT		; has there been an interrupt?
	jne	.L20			; yes, -> error

	call	DisplayPassedA
	jmp	.L30

.L20:
	in	al,i8255A		; read value
	push	ax

	mov	si,TxtStuckKey
	call	TextToScreen

	mov	si,TxtStuckKey2
	call	PlaceToScreen

	pop ax				; restore found key
	mov	ch,al			;  and move to CH

	mov	cl,4
	shr	al,cl			; get hi-nibble

	mov	bx,Tbl_ASCII
	xlatb				; transfer into ASCII

	mov	dx,SegmentMDA		; MDA screen
	mov	es,dx
	mov	ah,7			; attribute
	mov	[es:di],ax		; write to the MDA screen
	mov	[es:di+8000h],ax	; write to the CGA screen

	mov	al,ch			; get read byte again
	and	al,0Fh			; get lo-nibble

	mov	bx,Tbl_ASCII
	xlatb				; transfer into ASCII

	mov	ah,7			; attribute
	mov	[es:di+2],ax		; write to the MDA screen
	mov	[es:di+8002h],ax	; write to the CGA screen


	OutDebugB 9Ch

	mov	si,TxtChkKeybScan
	mov	bx,ErrKeybScan
	call	DisplayFailedA

; Disable all interrupts
.L30:
	mov	al,0FFh
	out	PIC8259+1,al

	cli				; disable interrupts

	mov	al,0FCh
	out	i8255A,al		; reset the keyboard


;**  Look for and check the Floppy Disk Controller
CheckFDC:
	OutDebugB 82

	mov	si,TxtChkFDC
	call	TextToScreenA

; Enable interrupts for the FDC
	mov	al,0BFh
	out	PIC8259+1,al

	mov	dx,FdcMotor

	xor	ax,ax
	mov	ds,ax			; DS := first segment

; Normal mode
	mov	al,0Ch
	out	dx,al

	nop
	nop

; Reset FDC
	mov	al,8
	out	dx,al

	nop
	nop

; Normal mode again
	mov	al,0Ch
	out	dx,al

	call	SenseIntStatus		; went OK?
	jb	.L99			; no, -> error

;* Perform the Specify command
	OutDebugB 84

	mov	ah,3			; specify
	call	ProgramFDC		; went OK?
	jb	.L99			; no, -> error found

	mov	ah,0CFh			; step rate time: 12 ms.
					; head unload time: 240 ms
	call	ProgramFDC		; went OK?
	jb	.L99			; no, -> error found

	mov	ah,2			; head load time: 6 ms
					; mode = DMA
	call	ProgramFDC		; went OK?
	jb	.L99			; no, -> error found

	mov	si,TxtChkFDC
	call	DisplayPassedA

	jmp	ChkReadFloppy

.L99:
	OutDebugB 9Eh

	mov	bx,ErrFDC
	mov	si,TxtChkFDC
	call	DisplayFailedA


;**  Checke if a floppy can be read
ChkReadFloppy:
	mov	si,TxtReadFloppy
	call	TextToScreenA

; Activate the motor of drive 0
	OutDebugB 86

	mov	dx,FdcMotor
	mov	al,1Ch
	out	dx,al

; Delay
	xor	cx,cx
.L10:
	loop	.L10

; Program the 8237
	mov	al,46h			; read command for DMA
	out	DMA8237+0Ch,al		;   diddle LSB/MSB flip-flop

	nop
	nop

	out	DMA8237+0Bh,al		;   send it to the 8237

; Set address where to store the read data = 0000:2000h
	xor	al,al
	out	DMA8237+4,al

	nop
	nop

	mov	al,20h			; store at 2000h
	out	DMA8237+4,al

	xor	al,al			; 0000
	out	DmaPageRegCh2,al	; 64K page number to DMA page reg

; Number of bytes to read, 512 = 01FFh 
	mov	al,0FFh
	out	DMA8237+5,al

	mov	al,1
	out	DMA8237+5,al

; Use channel 2
	mov	al,2
	out	DMA8237+10,al

; Start with drive 0
	xor	ax,ax			; first segment / drive A
	mov	ds,ax

; Recalibrate the drive
.L20:
	OutDebugB 88

	mov	[0480h],ah		; save AH

	mov	ah,7
	call	ProgramFDC

	mov	ah,[0480h]		; AH := drive
	call	ProgramFDC		; enter AH = drive

	call	SenseIntStatus		; went OK?
	jb	.L24			; no, -> 

	test	byte [0400h],0C0h	; status = OK?
	je	.L30			; yes, ->

.L24:
	or	byte [0480h],0		; drive A?
	jne	.error			; no, -> error

	mov	ah,1			; try next drive
	jmp	.L20

; Seek the drive
.L30:
	OutDebugB 90

	mov	ah,0Fh
	call	ProgramFDC

	mov	ah,[0480h]		; AH := drive
	call	ProgramFDC

	mov	ah,0	;;;GLEB 5			; goto track 5
	call	ProgramFDC

	call	SenseIntStatus		; went OK?
	jb	.error			; no, -> error

	test	byte [0400h],0C0h	; status = OK?
	jne	.error			; no, -> error

; Settle the head. For IBM: 25 * 550 = 13750. For turbo PCs I use 8000h
	mov	cx,8000h
.SettleHead:
	loop	.SettleHead

; Read data from the floppy
	mov	ah,66h			; one side, MFM, skip deleted data
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,[0480h]		; AH := drive, head 0
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,0	;;;GLEB 5			; goto track 5
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	xor	ah,ah			; head 0
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,1			; sector 1
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,2			; 512 bytes/sector
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,9			; last sector on the track
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,2Ah			; gap length
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

	mov	ah,0FFh			; data length = non-user defined
	call	ProgramFDC		; error found?
	jb	.error			; no, -> error

; Now wait for an interrupt
	OutDebugB 92

	call	CheckForINT
	je	.error			; no, -> error

	call	ReadDataFDC		; error found?
	jb	.error			; no, -> error

	test	byte [0400h], 0C0h	; status OK?
	jne	.error			; no, -> error

; Floppy read test = OK
	mov	si,TxtReadFloppy
	call	DisplayPassedA

	jmp	.L50

.error:
	OutDebugB 0A0h

	mov	bx,ErrFdcRead
	mov	si,TxtReadFloppy
	call	DisplayFailedA

; Stop the motors
.L50:
	OutDebugB 94

	mov	al,0Ch
	mov	dx,FdcMotor
	out	dx,al

	cli				;disable interrupts


;;;GLEB;**  Check the extra ROMs, if present
;;;GLEB	OutDebugB 96
;;;GLEB
;;;GLEB	mov	si,TxtRomF4000
;;;GLEB	call	TextToScreenA
;;;GLEB
;;;GLEB	mov	bx,ErrRomF400
;;;GLEB	mov	di,0F400h
;;;GLEB	call	DoChecksumRes
;;;GLEB
;;;GLEB	OutDebugB 98
;;;GLEB
;;;GLEB	mov	si,TxtRomF6000
;;;GLEB	call	TextToScreenA
;;;GLEB
;;;GLEB	mov	bx,ErrRomF600
;;;GLEB	mov	di,0F600h
;;;GLEB	call	DoChecksumRes
;;;GLEB
;;;GLEB	OutDebugB 100
;;;GLEB
;;;GLEB	mov	si,TxtRomF8000
;;;GLEB	call	TextToScreenA
;;;GLEB
;;;GLEB	mov	bx,ErrRomF800
;;;GLEB	mov	di,0F800h
;;;GLEB	call	DoChecksumRes
;;;GLEB
;;;GLEB	OutDebugB 102
;;;GLEB
;;;GLEB	mov	si,TxtRomFA000
;;;GLEB	call	TextToScreenA
;;;GLEB
;;;GLEB	mov	bx,ErrRomFA00
;;;GLEB	mov	di,0FA00h
;;;GLEB	call	DoChecksumRes
;;;GLEB
;;;GLEB	OutDebugB 104
;;;GLEB
;;;GLEB	mov	si,TxtRomFC000
;;;GLEB	call	TextToScreenA
;;;GLEB
;;;GLEB	mov	bx,ErrRomFC00
;;;GLEB	mov	di,0FC00h
;;;GLEB	call	DoChecksumRes


;**  Display the switch settings
; Note:	How to distinct between the PC and the XT? The settings of the first 
;	switch of the PC are obtained by reading port A of the 8255. Reading
;	port A of the 8255 of the XT should give 0FFh but that is not 
;	guaranteed. Assuming the used has one or two drives, switch 8 of SW1 is
;	set to "ON" and will set bit 7 to zero. The same can be said when 
;	reading the dip switches for the drives on a XT: here bit 7 will also
;	be zero and on a PC it will be one.
ReadSwitches:
	OutDebugB 106

;;;GLEB ->

	call	ReadJumpers184x		; BX = Both ES-1840/41 switches
					;                                              * ROM Scan NOT perform if 0 * <-.', 13, 10
					;     .-------On=DMA2 Ext.Box  .-.-------------FDD Number:00=1,01=2,10=3,11=4  |', 13, 10
					;     | .-----On=DMA3 Ext.Box  | | .-.---------CRT:00=NO,01=C40,10=C80,11=Mono |', 13, 10
					;     | | .---On=Speaker ON    | | | | .-------HDD:1(off)=Present,0(on)=Absent*/', 13, 10
					;     | | | .-On=DMA1 Ext.Box  | | | | | .-----FDD Tracks:1(off)=80,0(on)=40', 13, 10
					;     | | | |                  | | | | | | .---8087:1(off)=Instal,0(on)=Absent', 13, 10
					;     | | | | .-.-.-.-Not Used | | | | | | | .-Boot from:1(off)=FDD, 0(on)=HDD', 13, 10
					;     | | | | | | | |          | | | | | | | | ', 13, 10
					;     7 6 5 4 3 2 1 0          7 6 5 4 3 2 1 0  <- Switch/Bit Num, Pin1 = Bit7',13,10 
					;     ---------------          ---------------', 13, 10
					;           BH                        BL

	push	bx
	mov	si,TxtSwitch01
	call	TextToScreen

	mov	al,2
	mov	si, TxtSwitchUnr	; db  68, '(Unreadable)', 0
	call	TextToScreen2c

	mov	si,TxtSwitch02
	call	TextToScreen

	mov	al,3
	mov	si, TxtSwitchUnr	; db  68, '(Unreadable)', 0
	call	TextToScreen2c

	mov	si,TxtSwitch03
	call	TextToScreen

	mov	al,4
	mov	si, TxtSwitchUnr	; db  68, '(Unreadable)', 0
	call	TextToScreen2c

	mov	si,TxtSwitch04
	call	TextToScreen

	mov	al,5
	mov	si, TxtSwitchUnr	; db  68, '(Unreadable)', 0
	call	TextToScreen2c

	mov	si,TxtSwitch05
	call	TextToScreen

	mov	al,6
	mov	si, TxtSwitch4041	; db  55, '1840 RAM Size', 179, '1841 Unused', 0
	call	TextToScreen2c

	pop	bx
	push	bx
	mov	al, 06
	call	ShowJumperState

	mov	si,TxtSwitch06
	call	TextToScreen

	mov	al,7
	mov	si, TxtSwitch4041	; db  55, '1840 RAM Size', 179, '1841 Unused', 0
	call	TextToScreen2c

	pop	bx
	push	bx
	mov	al, 07
	call	ShowJumperState

	mov	si,TxtSwitch07
	call	TextToScreen

	mov	al,8
	mov	si, TxtSwitch4041	; db  55, '1840 RAM Size', 179, '1841 Unused', 0
	call	TextToScreen2c

	pop	bx
	push	bx
	mov	al, 08
	call	ShowJumperState

	mov	si,TxtSwitch08
	call	TextToScreen

	mov	al,9
	mov	si, TxtSwitch4041	; db  55, '1840 RAM Size', 179, '1841 Unused', 0
	call	TextToScreen2c

	pop	bx
	push	bx
	mov	al, 09
	call	ShowJumperState


	mov	si,TxtSwitch09
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 11
	call	ShowJumperState

	mov	si,TxtSwitch10
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 12
	call	ShowJumperState

	mov	si,TxtSwitch11
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 13
	call	ShowJumperState

	mov	si,TxtSwitch12
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 14
	call	ShowJumperState

	mov	si,TxtSwitch13
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 15
	call	ShowJumperState

	mov	si,TxtSwitch14
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 16
	call	ShowJumperState

	mov	si,TxtSwitch15
	call	TextToScreen

	pop	bx
	push	bx
	mov	al, 17
	call	ShowJumperState

	mov	si,TxtSwitch16
	call	TextToScreen

	pop	bx
	mov	al, 18
	call	ShowJumperState

;;;GLEB <-

;;;GLEB	mov	al,0F8h			; select SW1 (if PC) and hi-nibble of
;;;GLEB	out	i8255B,al		;  XT's dip switch block
;;;GLEB
;;;GLEB	xor	ah,ah			; clear collector
;;;GLEB	mov	cx,10			; read SW1 ten times
;;;GLEB.L04:
;;;GLEB	in	al,i8255A
;;;GLEB	or	ah,al			; OR result with collector
;;;GLEB	loop	.L04
;;;GLEB
;;;GLEB
;;;GLEB	and	ah,80h			; filter bit 7, zero = PC?
;;;GLEB	je	SwitchPC		; yes, ->
;;;GLEB
;;;GLEB	OutDebugB 108
;;;GLEB
;;;GLEB	xor	ah,ah			; clear collector
;;;GLEB	mov	cx,10			; read port C ten times
;;;GLEB.L08:
;;;GLEB	in	al,i8255A
;;;GLEB	or	ah,al			; OR result with collector
;;;GLEB	loop	.L08
;;;GLEB
;;;GLEB	and	ah,8			; filter bit 3, zero = XT?
;;;GLEB	je	SwitchXT		; yes, ->
;;;GLEB
;;;GLEB; Incorrect dip switch setting found
;;;GLEB	mov	si,TxtBadSwitch
;;;GLEB	mov	dh,70h			; set attribute character = inverted
;;;GLEB	call	TextToScreen2
;;;GLEB
;;;GLEB	jmp	DispTotalCount
;;;GLEB
;;;GLEB
;;;GLEBSwitchPC:
;;;GLEB	OutDebugB 110
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC2
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC3
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC4
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC5
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC6
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchPC7
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	ax,SegmentMDA		; start with MDA
;;;GLEB.L04:
;;;GLEB	mov	ds,ax
;;;GLEB	
;;;GLEB	mov	al,0F4h			; read first four switches
;;;GLEB	out	i8255B,al
;;;GLEB
;;;GLEB	in	al,i8255A		; read SW1
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT5
;;;GLEB	mov	di,5			; start at offset 5
;;;GLEB	call	SubSwitches
;;;GLEB
;;;GLEB	call	SubSwitches2
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT5
;;;GLEB	mov	di,19			; start at offset 5
;;;GLEB	call	SubSwitches
;;;GLEB
;;;GLEB	jmp	DispTotalCount
;;;GLEB
;;;GLEB
;;;GLEB
;;;GLEBSwitchXT:
;;;GLEB	OutDebugB 112
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT2
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT3
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT4
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT5
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT6
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT7
;;;GLEB	call	TextToScreen
;;;GLEB
;;;GLEB	mov	ax,SegmentMDA		; start with MDA
;;;GLEB.L04:
;;;GLEB	mov	ds,ax
;;;GLEB
;;;GLEB	mov	al,0F4h			; read first four switches
;;;GLEB	out	i8255B,al
;;;GLEB
;;;GLEB	call	SubSwitches2
;;;GLEB
;;;GLEB	mov	si,TxtSwitchXT5
;;;GLEB	mov	di,12			; start at offset 12
;;;GLEB	call	SubSwitches


;**  Display the total count
DispTotalCount:
	OutDebugB 124

	mov	si,TxtTotalCount
	call	TextToScreen

	mov	bx,TotalCount
	call	GetErrorValue

	mov	si,TxtTotalCount
	mov	di,18			; position on the line
	call	CalcSpotScreen

	call	DisplayValue

	OutDebugB 126

	jmp	DiagLoop




;-------------------------------------------------------------------------------
; Subroutines
;-------------------------------------------------------------------------------

;;;GLEB ->

ReadJumpers184x:

	pushf
	cli

	in	al, 61h			; Read Port A Value
	mov	ah, al			; Save it in AH

	or	al, 80h
	out	61h, al			; Enable DIP Switches1 read from Port A

	in	al, 60h			; Read DIP Switches1 from Port A
	mov	bl, al

	in	al, 62h			; Read Port C (0-3: values of DIP Switches2)
	mov	bh, al

	mov	al, ah
	out	61h, al			; Restore Port B

	and	bh, 0Fh			; BX - Jumpers (mask unused bits)

	popf

	ret

; AL = Y Position
ShowJumperState:

	cmp	al, 9
	jg	SecondHalf

	mov	cl, 9			; AL = 2...9
	jmp	CheckState

SecondHalf:
	mov	cl, 18			; AL = 11...18
	mov	bh, bl			; Replace jumpers bytes

CheckState:
	sub	cl, al			; CL = 7...0
	mov	dl, 1
	shl	dl, cl
	test	bh, dl
	jnz	JumperNotSet

	mov	si, TxtSwitch00_On1	; db  45, 196,196, 0
	call	TextToScreen2b

	mov	si, TxtSwitch00_On2	; db  49, '[ON] ', 0
	call	TextToScreen2b

	ret

JumperNotSet:
	mov	si, TxtSwitch00_Off1	; db  45, '  ', 0
	call	TextToScreen2b

	mov	si, TxtSwitch00_Off2	; db  49, '[OFF]', 0
	call	TextToScreen2b

	ret

; See TextToScreen for understanding
TextToScreen2b:
	mov	dh, 0Fh
	jmp	TextToScreen2d

TextToScreen2c:
	mov	dh, 07h

TextToScreen2d:
	push	ax
	push	bx
	call	TextToScreen2a
	pop	bx
	pop	ax

	ret

;;;GLEB <-

OutBeeep:
	out	80h,al			; IBM's debug port
	
	mov	dx,378h			; LPT 1
	out	dx,al

	dec	dh
	out	dx,al			; LPT 2

	cmp	al,6			; ready with screen?
	jb	Beeep.L50		; no, -> 

;**  PC speaker beep
; in:	AL = bit code: 1 = long beep, 0 = short beep
; Note:	The calling program must take care of a silent delay between two calls.
Beeep:
	or	al,al			; valid value?
	je	.L50			; no, -> exit

	mov	dl,al			; save original value
	mov	bl,al			; use BL as work value
	mov	bh,8			; counter
.L04:
	test	bl,80h			; bit 7 set?
	jne	.L10			; yes, -> 

	dec	bh
	shl	bl,1			; rotate next bit into bit 7
	jmp	.L04

.L10:
	mov	al,10110110b		; Timer IC 8253 square waves
	out	PIT8253Ctrl,al		;   channel 2, speaker

	mov	ax,528h			; Get countdown constant word
	out	PIT8253C,al		;   send low order

	mov	al,ah			;   load high order
	out	PIT8253C,al		;   send high order

	in	al,i8255B		; Read IC 8255 machine status
	mov	ah,al			; save settings of speaker port

	or	al,3
	out	i8255B,al		; Turn speaker on

	xor	cx,cx			; clear counter

	mov	al,1			; short beep

	test	bl,80h			; short beep indeed?
	je	.L20			; yes, ->

	mov	al,3			; long beep
.L20:
	loop	.L20

	dec	al
	jnz	.L20

	mov	al,ah			; restore original value
	out	i8255B,al		; Turn speaker off

	dec	bh			; more beeps?
	je	.L50			; no, -> exit

	shl	bl,1			; rotate BL

; silent delay
.L30:
	loop	.L30
.L40:
;	loop	.L40
	jmp	short .L10

.L50:
	mov	al,dl			; restore original AL
	ret



;**  Calculate the spot on the screen where to place some text
; in:	DI = offset on the line in number of chars
;	SI = points to the line number
; out:	DI = offset on the screen
; used:	AX, CH, DS
CalcSpotScreen:
	push	ax			; save AX

	shl	di,1			; DI := DI * 2 because of attribute

	mov	al,[cs:si]		; get row
	inc	si

	xor	ah,ah
	mov	ch,160			; = 2 * 80 (character + attribute)
	mul	ch			; AX := start of the line
	add	di,ax			; save result

	mov	al,[cs:si]		; get column

	xor	ah,ah
	shl	ax,1			; AX := AX * 2 because of attribute
	add	di,ax			; save end result

	pop	ax			; restore AX
	ret



;** Check if an interrupt has ocured
; out:	Zero flag, clear = none, set = yes
CheckForINT:
	xor	ah,ah			; clear AH = flag

	sti				; enable interrupts

; Delay
	mov	bl,4
	xor	cx,cx
.wait:
	or	ah,ah			; has there been an interrupt?
	jne	.end			; yes, -> 

	loop 	.wait 			; Keayboard must send init code now

	dec	bl
	jne	.wait
.end:
	cli	
	ret	


 
;**  Check a block of memory on write/read and pairty errors
; in:	CX = amount of memory in bytes to be tested
;	ES = segment
; out:	Carry: set = error, clear = OK
CheckMemory:
	mov	dx,i8255B
	in	al,dx
	or	al,30h			; clear old memory parity error
	out	dx,al

	mov	dx,cx			; save CX
	mov	ax,es
	mov	ds,ax

;* First "clear" the memory to make sure the parity bit is set right
; Write to memory
	xor	ax,ax
	mov	di,ax
	mov	si,ax
	repz	stosw

; Now read it
	mov	cx,dx
	rep	lodsw

; Write to memory again with other parity value
	mov	ax,0FF7Fh
	xor	di,di
	mov	cx,dx
	repz	stosw

; And now read it again
	xor	si,si
	mov	cx,0400h		; 
	rep	lodsw

; Enable parity
	mov	dx,i8255B
	in	al,dx
	and 	al,0CFh
	out	dx,al

;* Now the actual test
	mov	ah,55h

; Write the memory
.L10:
	mov	al,ah

	mov	cx,dx
	xor	di,di
	rep	stosb

; Long delay to check if refresh works as it should
	mov	al,1
 mov cx,2	
.L20:
	loop	.L20

	dec	al			; more waiting to do?
	jne	.L20			; yes, ->

	xor	di,di
	mov	cx,dx			; restore CX
.L30:
	cmp	ah,[es:di]		; same as original written value?
	jne	.L90			; no, -> error

	in	al,i8255C
	test	al,0C0h			; parity error?
	jne	.L96			; yes, ->

	loop	.L30	

	cmp	ah,0AAh			; 2nd check done?
	je	.L40			; yes, -> exit

	not	ah			; AH := 0AAh
	jmp	.L10

; Test went well completely
.L40:
	clc
	ret

.L90:
	stc
	ret

 
.L96:
; Parity error found
	in	al,61h
	or	al,30h			; disable parity
	out	61h,al

	stc
	ret



;**  Output a debug code to the last positions of the first line
; in:	AL = code
DebugScreen:
	push	ax
	push	cx
	push	ds

	mov	cx,SegmentMDA
	mov	ds,cx			; ES points to MDA screen

	mov	ah,7			; attribute
	mov	ch,al			; save AL
	
	mov	cl,4
	shr	al,cl			; 1234 xxxx -> 0000 1234
	or	al,30h
	cmp	al,3Ah			; 0..9 ?
	jb	.L20			; yes, -> 

	add	al,7			; A..F
.L20:
	mov	[9Ch],ax
	mov	[809Ch],ax		; update CGA screen

	mov	al,ch			; restore AL
	and	al,0Fh			; xxxx 1234 -> 0000 1234
	or	al,30h
	cmp	al,3Ah			; 0..9 ?
	jb	.L40			; yes, -> 

	add	al,7			; A..F
.L40:
	mov	[9Eh],ax
	mov	[809Eh],ax		; update CGA screen

	pop	ds
	pop	cx
	pop	ax

	ret



;**  Delay three complete CX loops
Delay3:
	xor	cx,cx
.L10:
	loop	.L10
.L20:
	loop	.L20
.L30:
	loop	.L30

	ret



;**  Display critical message on the screen
; in:	SI points to original message
DispCritical:
	mov	ax,cs
	mov	ds,ax

; Calculate position on the screen
	cld	
	lodsb				; read row of original message

	add	al,2			; skip two lines

	mov	ch,0A0h
	mul	ch
	mov	di,ax			; DI := start of line on screen

	add	di,4			; start of critical message

	mov	si,TxtCritical
	mov	dh,70h			; char attribute = inverted

	jmp	TextToScreen3



;**  Display the text "FAILED" behind message in DX
; in:	SI points to original message
DisplayFailed:
	mov	dx,TxtFailed
	mov	bl,70h			; char attribute = inverted
	jmp	DispSecondMsg2


 
;**  Display the text "FAILED" behind message in DX and remove the arrow
; in:	SI points to original message
;	BX points to the byte containing the value 
DisplayFailedA:
	push	si
	push	bx

	mov	di,26			; position on the line
	call	CalcSpotScreen

; DI now points to the correct possition on the screen
	pop	bx
	call	GetErrorValue

; DX/BL contains decimal number
; DI contains location on the screem
	pop	si
	push	si
	call	DisplayValue

	mov	dx,TxtFailed
	mov	bl,70h			; char attribute = inverted
	call	DispSecondMsg2

	pop	si

	jmp	RemoveArrow


 
;**  Display the text "PASSED" behind message in DX
; in:	SI points to original message
DisplayPassed:
	mov	dx,TxtPassed
	jmp	DispSecondMsg



;**  Display the text "PASSED" behind message in DX and remove the arrow
; in:	SI points to original message
DisplayPassedA:
	push	si

	mov	dx,TxtPassed
	call	DispSecondMsg

	pop	si

	jmp	RemoveArrow



;**  Display decimal value in DH/DL/BL on CGA and MDA screen
; in:	BL = ones
;	DL = tens
;	DH = hundreds
;	DI = place on screen
DisplayValue:
	mov	ax,SegmentMDA		; MDA
	mov	es,ax

	cmp	dh,'0'			; skip hundreds?
	ja	.L10			; no, -> display number

	mov	dh,' '			; fill hundreds with a space

	cmp	dl,'0'			; skip tens?
	jne	.L10			; no, ->

	mov	dl,' '			; fill tens with a space
.L10:
	mov	[es:di],dh		; hundreds -> MDA
	add	di,8000h
	mov	[es:di],dh		; hundreds -> CGA
	sub	di,7FFEh

	mov	[es:di],dl		; tens -> MDA
	add	di,8000h
	mov	[es:di],dl		; tens -> CGA
	sub	di,7FFEh

	mov	[es:di],bl		; ones -> MDA
	add	di,8000h
	mov	[es:di],bl		; ones -> CGA

	ret


 
;**  Display a status message behind a previous one
; in:	SI points to original message
;	DX points to Passed / FAILED that should be written after
;	   the SI message
DispSecondMsg:
	mov	bl,07h			; char attribute = normal
DispSecondMsg2:
	mov	ax,cs
	mov	ds,ax

; Calculate position on the screen
	cld	
	lodsb				; read row, inc SI

	mov	ch,0A0h
	mul	ch
	mov	di,ax			; DI := start of line on screen

	lodsb				; read column
	cbw				; AX := AL
	shl	ax,1			; double for attribute
	add	di,ax			; DI := start of 2nd message on screen
	add	di,30*2			; start of Passed / FAILED

	mov	si,dx			; SI := Passed / FAILED / NOT PRESENT
	mov	dh,bl			; char attribute

	jmp	TextToScreen3



;**  Convert ES to decimal for displaying amount of RAM
; in:	ES = segment
; out:	BL = ones
;	DL = tens
;	DH = hundreds
; used:	AX, CL
ES2DEC:
	mov	ax,es
	mov	cl,6
	shr	ax,cl			; AX := AX div 64 = number of KB



;**  Convert AX to decimal 
; in:	AX = number
; out:	BL = ones
;	DL = tens
;	DH = hundreds
; used:	AX
AX2DEC:			;;;GLEB AL2DEC:
	mov	dx,3030h		; hundreds and tens
AX2DEC2:		;;;GLEB
	cmp	ax,100	;;;GLEB al,100	; smaller than 99?
	jb	.L30			; yes, ->

	inc	dh
	sub	ax,100	;;;GLEB al,100	; subtract 100
	jmp	AX2DEC2	;;;GLEB AL2DEC	; another check for hundreds

.L30:
	cmp	al,10			; smaller than 9?
	jb	.L40			; yes, ->

	inc	dl
	sub	al,10			; subtract 10
	jmp	.L30			; another check for tens

;* Display results
.L40:
	or	al,30h			; number -> ASCII
	mov	bl,al			; save AL

	ret



;** Perform a checksum on a 8 KB ROM in the F000 segemnt
; in:	DI = start of 8 KB range
; Note:	A range full with 0FFh bytes will end up as well with a checksum of 
;	zero. If we find 2000h FFs, then there is no ROM at all. This is 
;	something the Landmark ROM does not notice.
DoChecksum:
	push	si

	mov	cx,2000h
	xor	dx,dx			; use as FF counter
	xor	si,si			; clear source pointer
	
	mov	ax,cs
	mov	ds,ax			; DS := CS = 0F000h

	xor	ah,ah			; AH := zero, clear the checksum

; Add the content of every byte in this ROM
.L30:
	lodsb				; read from the possible ROM
	add	ah,al			; add to the checksum

	cmp	al,0FFh			; AL = 0FFH?
	jne	.L40			; no, -> skip counter

	inc	dx			; increment 0FFh counter
.L40:
	loop	.L30

	or	ah,ah			; result is zero?
	jne	.L99			; no, -> bad checksum, exit
	
	cmp	dx,2000h		; all bytes are 0FFh?
	jne	.L50			; no, -> good chance it is a ROM

	inc	ah			; make sure zero flag will reset
.L50:
	or	ah,ah			; set or reset zero flag
.L99:
	pop	si
	ret



;**  Perform a checksum and display the result
; in:	DI = start of 8 KB range
;	SI = text info
DoChecksumRes:
	call	DoChecksum
	je	.L10

	jmp	DisplayFailedA

.L10:
	jmp	DisplayPassedA



;**  Retrieve the error counter value from the invisible screen memory
; in: 	BX points to the byte containing the value
GetErrorValue:
	mov	ax,SegmentMDA
.L10:
	mov	ds,ax

	cmp	word [ControlWord],5C3Ah
	je	.L20

	mov	ax,ds
	cmp	ax,SegmentMDA		; just checked MDA?
	je	.L14			; yes, -> do CGA now

	xor	al,al			; display zero
	jmp	.L30

.L14:
	mov	ax,SegmentCGA
	jmp	.L10

.L20:
	inc	byte [bx]
	mov	al,[bx]			; read increased counter

.L30:
	xor	ah, ah	;;;GLEB
	jmp	AX2DEC	;;;GLEB AL2DEC		; convert AL to decimal



;**  Wait for the 765 to be ready and prgram diskette command/data register 0
; in:	AH = byte for 03F5h = diskette command/data register 0
; out:	Carry, clear = OK, set = bad
ProgramFDC:
	mov	dx,FdcStatus
	xor	cx,cx

; Check if "transfer is from controller to system" and "RQM data register is
; ready".
	mov	bl,4
.L10:
	in	al,dx
	and	al,0C0h
	cmp	al,80h			; Check = OK?
	je	.L20			; yes, -> 

	loop	.L10

	dec	bl
	jne	.L10

	stc	
	ret	

; Program diskette command/data register 0
.L20:
	inc	dx			; DX := 03F5h

	mov	al,ah
	out	dx,al

	clc	
	ret	



;**  Read data from the 765 floppy controller
; out:	Carry, clear = OK, set = bad
ReadDataFDC:
	mov	dx,FdcStatus

	xor	cx,cx
	mov	ds,cx			; DS points to first segment
.L10:
	in	al,dx
	and	al,0C0h
	cmp	al,0C0h			; RQM data register is ready?
					; transfer = from controller to system?
	je	.L20			; yes, -> OK

	loop	.L10

	jmp	.error


 ; Read diskette command/data register 0 
.L20:
	mov	bl,7			; maximal 7 bytes to be read
	xor	si,si

	inc	dx			; DX := 03F5
.L40:
	in	al,dx
	mov	[si+0400h],al		; store read value

	inc	si

; Delay for NEC
	mov	cx,10
.L50:
	loop	.L50

	dec	dx
	in	al,dx

	inc	dx
	test	al,10h			; seek completed?
	jne	.L60			; no, -> continue

; Exit
	clc	
	ret

.L60:
	dec	bl			; another byte to read?
	jne	.L40			; yes, ->

; Error
.error:
	stc	
	ret	



;**  Handle a real test interrupt
RealINT:
	in	al,PIC8259
	or	ah,al

	mov	al,20h			; end-of-interrupt command
	out	PIC8259,al

	iret	



;**  Handle a real NMI
RealNMI:
	xor	al,al
	out	NmiPort,al		; disable NMI interrupts

	mov	ah,1
	iret



;**  FDC command: Sense interrupt status
SenseIntStatus:
	xor	ax,ax
	mov	ds,ax

; Now wait for an interrupt
	call	CheckForINT		; has there been an interrupt?
	je	.L98			; no, -> error = exit

	mov	ah,8			; sense interupt status
	call	ProgramFDC		; went OK?
	jb	.L99			; no, -> error found = exit

	call	ReadDataFDC		; error found?
	jb	.L99			; yes, -> error found = exit

	clc
	ret

.L98:
	stc
.L99:
	ret



;**  Remove the arrow placed at the start of the test
; in:	SI points to parameters of original text 
RemoveArrow:
	mov	dl,1
	jmp	SubArrow

;**  Show an arrow on the screen so the user knows where the ROM is busy
; in:	SI points to parameters of original text 
ShowArrow:
	xor	dl,dl			; show arrow

SubArrow:
	mov	ax,cs
	mov	ds,ax

; Calculate position on the screen
	cld	
	lodsb				; read row, inc SI

	mov	ch,0A0h
	mul	ch
	mov	di,ax			; DI := start of line on screen

	lodsb				; read column
	cbw				; AX := AL
	shl	ax,1			; double for attribute
	add	di,ax			; DI := start of 2nd message on screen
	sub	di,4			; start of '->'

	mov	dh,7			; char attribute

	or	dl,dl			; show arrow?
	jne	.L10			; no, -> 

	mov	si,TxtShowArrow
	jmp	.L20

.L10:
	mov	si,TxtRemoveArrow
.L20:
	jmp	TextToScreen3

TxtRemoveArrow:
	db '  ', 0

TxtShowArrow:
	db '->', 0



;**  Subroutine for outputting debug code on the LPT port and IBM's debug port
sOutDebug:
	out	80h,al			; IBM's debug port
	
	mov	dx,378h			; LPT 1
	out	dx,al

	dec	dh
	out	dx,al			; LPT 2

	ret



;;;GLEBSubSwitches:
;;;GLEB	call	CalcSpotScreen
;;;GLEB
;;;GLEB	mov	cx,8			; switch counter
;;;GLEB.L08:
;;;GLEB	shr	al,1			; shift momentary bit 1 into Carry
;;;GLEB	jb	.L12			; if set, -> bottom row
;;;GLEB
;;;GLEB; Place 'X' on top row
;;;GLEB	mov	byte [di],'X'
;;;GLEB	jmp	.L16
;;;GLEB
;;;GLEB
;;;GLEB; Place 'X' on bottom row
;;;GLEB.L12:
;;;GLEB	mov	byte [di+160],'X'
;;;GLEB.L16:
;;;GLEB	inc	di
;;;GLEB	inc	di
;;;GLEB	loop	.L08
;;;GLEB
;;;GLEB	ret
;;;GLEB
;;;GLEB
;;;GLEB
;;;GLEBSubSwitches2:
;;;GLEB	in	al,i8255C
;;;GLEB	and	al,15			; isolate the four switches
;;;GLEB	mov	bl,al			; temporary storage
;;;GLEB
;;;GLEB	mov	al,0FCh			; read second four switches
;;;GLEB	out	i8255B,al
;;;GLEB
;;;GLEB	in	al,i8255C
;;;GLEB
;;;GLEB	mov	cl,4
;;;GLEB	shl	al,cl			; xxxx 8765  -->  8765 0000
;;;GLEB	or	al,bl			; combine results
;;;GLEB
;;;GLEB	ret



;**  Output text, with preset or custom attribute.
; in:	SI points to parameters for the text to be displayed
; used:	AX, BP, BX, CX, DI, DS, DX, ES
; Parameters:
; 1st byte:	row
; 2nd byte:	column
; The text starts at the 3rd byte
TextToScreen:
	mov	dh,07h			; set attribute for character

TextToScreen2:
	mov	ax,cs
	mov	ds,ax

	cld	
	lodsb				; get row

TextToScreen2a:				;;;GLEB
	xor	ah,ah
	mov	ch,160			; = 2 * 80 (character + attribute)
	mul	ch
	mov	di,ax			; save result

	lodsb				; get column

	xor	ah,ah
	shl	ax,1
	add	di,ax			; DI := place where to copy the text to

TextToScreen3:
	mov	ah,dh			; set attribute for character

; Copy the text to the screen
	mov	dx,SegmentMDA		; MDA screen
	mov	es,dx

	mov	bp,di			; save DI
	mov	bx,si			; save SI
	mov	dx,cx			; save CX
.L10:
	lodsb				; read character
	and	al,al			; end of the text?
	je	.L20			; yes, -> 

	stosw				; write character plus attribute
	jmp	.L10

.L20:
	mov	cx,es
	cmp	cx,SegmentCGA		; did we do CGA already?
	je	.L30			; yes, -> exit

; Copy the text to the CGA screen
	mov	di,bp			; restore DI
	mov	si,bx			; restore SI
	mov	cx,dx			; restore CX

	mov	dx,SegmentCGA		; CGA screen
	mov	es,dx

	jmp	.L10

.L30:
	mov	si,bx
	sub	si,2			; restore original SI

	ret	



;**  Output text, with preset or custom attribute and display an arrow
; in:	SI points to parameters for the text to be displayed
; used:	AX, BP, BX, CX, DI, DS, DX, ES
; Parameters:
; 1st byte:	row
; 2nd byte:	column
; The text starts at the 3rd byte
TextToScreenA:
	push	si

	call	TextToScreen
	call	ShowArrow

	pop	si
	ret



;**  Calculate the place on the screen to output characters
; Note: cannot be used by TextToScreen because no subroutines are allowed
;	during the ROM-only-mode
PlaceToScreen:
	mov	ax,cs
	mov	ds,ax

	cld	
	lodsb				; get row

	xor	ah,ah
	mov	ch,160			; = 2 * 80 (character + attribute)
	mul	ch
	mov	di,ax			; save result

	lodsb				; get column

	xor	ah,ah
	shl	ax,1
	add	di,ax			; DI := place where to copy the text to

	ret



;**  Update the error counter in front of the text FAILED
;	using RAM stack
; in:	BX points to the correct counter
;	SI points to the line number
UpdErrorCountB:
	mov	di,26			; position on the line
	call	CalcSpotScreen



	ret



;-------------------------------------------------------------------------------
; Data
;-------------------------------------------------------------------------------


Tbl_ASCII:
	db '0123456789ABCDEF'
	 

;**  Tables with data to initialise the MDA and CGA screen
Tbl_dataMDA:
	db 061h, 050h, 052h, 00Fh, 019h, 006h, 019h, 019h
	db 002h, 00Dh, 00Bh, 00Ch, 000h, 000h, 000h, 000h


Tbl_dataCGA:
	db 071h, 050h, 05Ah, 00Ah, 01Fh, 006h, 019h, 01Ch
	db 002h, 007h, 006h, 007h, 000h, 000h, 000h, 000h
 


;**  Various message outputted during the test 
TxtVersion:
;;;GLEB	db  0,  8, "Ruud's Diagbostics ROM for PC/XT    "
	db  0,  0, "Ruud's Diagnostics ROM clone for ES-1840/41 by Gleb Larionov (GlebLar@gmail.com)", 0
;;;GLEB	db 'Ver: '
;;;GLEB	db __DATE__, 32		; Release date (YYYY-MM-DD)
;;;GLEB	db __TIME__, 0		; Release time (uu:mm:ss)

;;;GLEB ->
TxtVersion2:
	db 24, 42, 'Version timestamp: '
	db __DATE__, 32		; Release date (YYYY-MM-DD)
	db __TIME__, 0		; Release time (uu:mm:ss)
;;;GLEB <-

TxtTestCPU:
	db  2,  2, 'Testing CPU', 0

TxtChecksumROM:
;;;GLEB	db  3,  2, 'Diagnostic ROM checksum', 0
	db  3,  2, 'This ROM checksum', 0

Txt8253Ch0:
	db  4,  2, '8253 timer channel 0', 0

Txt8253Ch1:
	db  5,  2, '8253 timer channel 1', 0

Txt8253Ch2:
	db  6,  2, '8253 timer channel 2', 0

Txt8237DMA:
	db  7,  2, '8237A DMA controller', 0
	
Txt8255Parity:
	db  8,  2, '8255 parity check', 0

TxtChk2KbRAM:
	db  9,  2, 'Check first 2 KB of RAM', 0

TxtChkAllRAM:
	db 10,  2, 'Checked RAM:   2 KB', 0

TxtBadMemory:
	db 11,  2, 'Bad memory at     KB', 0

TxtEndOfMemory:
	db 11,  2, 'End of memory at     KB', 0

TxtNoMemError:
	db 11,  2, 'No memory error found', 0

TxtBadBits:
	db 12,  2, 'Bad bits:  7 6 5 4 3 2 1 0  P', 0

TxtPIC8259:
	db 14,  2, '8259 interrupt controller', 0

TxtCheckBadIRQ:
;;;Gleb	db 15,  2, 'Looking for bad interrupt', 0
	db 15,  2, 'Looking bad interrupt', 0

TxtCheckINT0:
	db 16,  2, 'Checking INT 0', 0

TxtCheckNMI:
	db 17,  2, 'Checking nonmaskable INT', 0

TxtCheckMDA:
	db 18,  2, 'Checking MDA + memory', 0

TxtCheckCGA:
	db 19,  2, 'Checking CGA + memory', 0

TxtCheck8087:
;;;GLEB	db 20,  2, 'Checking 8087 coprocessor', 0
	db 20,  2, 'Checking 8087 coproc.', 0

TxtChkKeybCont:
;;;GLEB	db 21,  2, 'Check keyboard controller', 0
	db 21,  2, 'Check KBD controller', 0

TxtChkKeybScan:
;;;GLEB	db 22,  2, 'Check keyboard scan lines', 0
	db 22,  2, 'Check KBD scan lines', 0

TxtChkFDC:
	db 23,  2, 'Check floppy controller', 0

TxtReadFloppy:
	db 24,  2, 'Try to read a floppy', 0






;;;GLEBTxtRomF4000:
;;;GLEB	db  2, 42, 'Check ROM at F4000', 0
;;;GLEB
;;;GLEBTxtRomF6000:
;;;GLEB	db  3, 42, 'Check ROM at F6000', 0
;;;GLEB
;;;GLEBTxtRomF8000:
;;;GLEB	db  4, 42, 'Check ROM at F8000', 0
;;;GLEB
;;;GLEBTxtRomFA000:
;;;GLEB	db  5, 42, 'Check ROM at FA000', 0
;;;GLEB
;;;GLEBTxtRomFC000:
;;;GLEB	db  6, 42, 'Check ROM at FC000', 0
;;;GLEB
;;;GLEB
;;;GLEBTxtBadSwitch:
;;;GLEB	db  8, 42, 'BAD SWITCH SETTING!', 0
;;;GLEB
;;;GLEBTxtSwitchPC:
;;;GLEB	db  8, 42, 'Switch settings for the PC', 0
;;;GLEB
;;;GLEBTxtSwitchXT:
;;;GLEB	db  8, 42, 'Switch settings for the XT', 0
;;;GLEB
;;;GLEBTxtSwitchPC2:
;;;GLEB	db 10, 42, '       SW1           SW2   ', 0
;;;GLEB
;;;GLEBTxtSwitchXT2:
;;;GLEB	db 10, 42, '               SW          ', 0
;;;GLEB
;;;GLEBTxtSwitchPC3:
;;;GLEB	db 11, 42, '    '
;;;GLEB	db 218, 196, 196, 196, 196, 196, 196, 196, 196, 191,
;;;GLEB	db '    '
;;;GLEB	db 218, 196, 196, 196, 196, 196, 196, 196, 196, 191, 0
;;;GLEB;	db 11, 42, '    Ŀ    Ŀ', 0
;;;GLEB
;;;GLEBTxtSwitchXT3:
;;;GLEB	db 11, 42, '           '
;;;GLEB	db 218, 196, 196, 196, 196, 196, 196, 196, 196, 191, 0
;;;GLEB;	db 11, 42, '           Ŀ       ', 0
;;;GLEB
;;;GLEBTxtSwitchPC4:
;;;GLEB	db 12, 42, '    ', 179, '12345678', 179
;;;GLEB	db '    ', 179, '12345---', 179, 0
;;;GLEB;	db 12, 42, '    12345678    12345---', 0
;;;GLEB
;;;GLEBTxtSwitchXT4:
;;;GLEB	db 12, 42, '           ', 179, '12345678', 179, '       ', 0
;;;GLEB;	db 12, 42, '           12345678       ', 0
;;;GLEB
;;;GLEBTxtSwitchPC5:
;;;GLEB	db 13, 42, ' ON ', 179, '        ', 179
;;;GLEB	db '    ', 179, '        ', 179, '', 0
;;;GLEB;	db 13, 42, ' ON                     ', 0
;;;GLEB
;;;GLEBTxtSwitchXT5:
;;;GLEB	db 13, 42, '        ON ', 179, '        ', 179, '       ', 0
;;;GLEB;	db 13, 42, '        ON                ', 0
;;;GLEB
;;;GLEBTxtSwitchPC6:
;;;GLEB	db 14, 42, '    ', 179, '        ', 179
;;;GLEB	db '    ', 179, '        ', 179, '', 0
;;;GLEB;	db 14, 42, '                        ', 0
;;;GLEB
;;;GLEBTxtSwitchXT6:
;;;GLEB	db 14, 42, '           ', 179, '        ', 179, '       ', 0
;;;GLEB;	db 14, 42, '                          ', 0
;;;GLEB
;;;GLEBTxtSwitchPC7:
;;;GLEB	db 15, 42, '    '
;;;GLEB	db 192, 196, 196, 196, 196, 196, 196, 196, 196, 217,
;;;GLEB	db '    '
;;;GLEB	db 192, 196, 196, 196, 196, 196, 196, 196, 196, 217, 0
;;;GLEB;	db 15, 42, '        ', 0
;;;GLEB
;;;GLEBTxtSwitchXT7:
;;;GLEB	db 15, 42, '           '
;;;GLEB	db 192, 196, 196, 196, 196, 196, 196, 196, 196, 217, 0
;;;GLEB;	db 15, 42, '                  ', 0

;;;GLEB ->

TxtSwitch00_On1:
	db  45, 196,196, 0
TxtSwitch00_Off1:
	db  45, '  ', 0

TxtSwitch00_On2:
	db  49, '[ON] ', 0
TxtSwitch00_Off2:
	db  49, '[OFF]', 0

TxtSwitchUnr:
	db  68, '(Unaccess)', 0
TxtSwitch4041:
	db  55, '1840 RAM Size', 179, '1841 Unused', 0


TxtSwitch01:
	db  2, 42, 'J ', 249,'  ',254,   ' [OFF] DMA2 Ext.Box', 0
	                                         
TxtSwitch02:                                     
	db  3, 42, 'M ', 249,'  ',249,   ' [OFF] DMA3 Ext.Box', 0
	                                         
TxtSwitch03:                                     
	db  4, 42, 'P ', 249,196,196,249,' [ON]  Speaker', 0
	                                         
TxtSwitch04:                                     
	db  5, 42, 'R ', 249,'  ',249,   ' [OFF] DMA1 Ext.Box', 0

TxtSwitch05:
	db  6, 42, '  ', 249,'  ',249,   ' ', 0

TxtSwitch06:                                     
	db  7, 42, 'D ', 249,'  ',249,   ' ', 0
	                                         
TxtSwitch07:                                     
	db  8, 42, '0 ', 249,'  ',249,   ' ', 0
	                                         
TxtSwitch08:                                     
	db  9, 42, '4 ', 249,'  ',249,   ' ', 0



TxtSwitch09:                                     
	db 11, 42, 'J ', 249,'  ',254,   ' [OFF] FDD Num.:1=1,1=2,0=3,0=4 ', 0

TxtSwitch10:                                     
	db 12, 42, 'M ', 249,'  ',249,   ' [OFF] FDD Num.:1   0   1   0   ', 0

TxtSwitch11:                                     
	db 13, 42, 'P ', 249,'  ',249,   ' [OFF] CRT:1=NO,1=C40,0=C80,0=BW', 0

TxtSwitch12:                                     
	db 14, 42, 'R ', 249,'  ',249,   ' [OFF] CRT:1    0     1     0   ', 0

TxtSwitch13:                                     
	db 15, 42, '  ', 249,'  ',249,   ' [OFF] HDD Present:OFF=Yes,ON=No', 0

TxtSwitch14:                                     
	db 16, 42, 'H ', 249,'  ',249,   ' [OFF] FDD Tracks: OFF=80, ON=40', 0

TxtSwitch15:                                     
	db 17, 42, '0 ', 249,'  ',249,   ' [OFF] 8087 Instal:OFF=Yes,ON=No', 0

TxtSwitch16:                                     
	db 18, 42, '4 ', 249,'  ',249,   ' [OFF] Boot from:Off=FDD, On=HDD', 0

;;;GLEB <-

TxtTotalCount:
;;;GLEB	db 18, 42, 'Completed passes:', 0
	db 20, 42, 'Completed pass:', 0

TxtStuckKey:
	db 22, 42, 'Stuck key found:          ', 0

TxtStuckKey2:
	db 22, 59



TxtCritical:
;;;GLEB	db 'Critical error, diagnostics heave been stopped!', 0
	db 'Critical error, stop!', 0	;;;GLEB

TxtFailed:
;;;GLEB	db 'FAILED', 0
	db 'FAIL', 0

TxtPassed:
;;;GLEB	db 'Passed', 0
	db 'Pass', 0



;-------------------------------------------------------------------------------


	setloc	0FFF0h

;------------------------------------------------------------------------------
; Power-On Entry Point
;------------------------------------------------------------------------------
PowerOn:
	jmp	0F000h:ColdStart

 
S_FFF5:
	db __DATE__		; Release date (YYYY-MM-DD)

	db 00h			; checksum
	
 

